﻿var bg_loading,countdown;

function Animate() {
    window.requestAnimationFrame(Animate);
    Draw();
}

function DrawBadge(x, y, level, type) {
    var sx = 0,
        sy = 0,
        btn = null;

    if (level == 1 || game.score[level - 1] != undefined) {

        if (type == 1) {
            sx = 0;
        } else if (type == 2) {
            sx = 92;
        } else if (type == 3) {
            sx = 184;
        } else if (type == 4) {
            sx = 276;
        } else if (type == 5) {
            sx = 368;
        }

        game.ctx3.drawImage(
            GetImg('level_badges'),
            sx, sy,
            92, 67,
            x, y + game.padding,
            92, 67);

        var btn = GetNewButton(game.ctx3, x - 4, y + game.padding, 100, 90, GetImg('level_badges'), game.sounds.click, sx, sy);
        btn.call = 'LevelGo';
        btn.params = [level];
        btn.active = true;
        game.buttons.push(btn);
        if (game.score[level - 1] != undefined) {
            DrawMenuScore(x, y + 52 + game.padding, game.score[level - 1]);
        }

        var xlevel = x + 32;
        if (level > 9) xlevel -= 17;

        txtsmall.text = level;
        txtsmall.x = xlevel;
        txtsmall.y = y + 12 + game.padding;
        txtsmall.draw();

    } else {
        var btn = GetNewButton(game.ctx3, x, y + game.padding, 92, 67, GetImg('lockedlevel'), game.sounds.click);
        btn.call = 'LevelLocked';
        btn.params = [level];
        btn.draw();
        game.buttons.push(btn);
    }

}

function LevelLocked(level) {
    Message('Locked Level', 'Pass the previous level to unlock this level.', ['Ok'], Ok);
}

function Menu() {
    var level = GetLocalStorage('MARS_LEVEL', game.level);

    game.menu = true;
    game.attempts = 0;

    enemies.reset();
    sprites.reset();
    FreeButtons();
    
    if (level > 25) NextWorld();
    else World();

    DrawTile(game.ctx0, GetImg('bg_night'));

}
function World() {

    game.attempts = 0;
    player.crash = false;
    player.landed = false;
    player.landedsplash = false;
    game.paused = false;
    game.play = false;
    game.intro = false;
    game.screen = 'menu';
    game.world = 1;
    HideAd();
    
    FreeButtons();

    game.ctx3.clearRect(0, 0, game.width, game.height);
    game.ctx3.drawImage(GetImg('mars'), 0, game.padding);

    DrawBadge(265, 116, 1, 1);
    DrawBadge(377, 57, 2, 1);
    DrawBadge(512, 58, 3, 2);
    DrawBadge(515, 171, 4, 2);
    DrawBadge(381, 193, 5, 1);
    DrawBadge(209, 231, 6, 3);
    DrawBadge(78, 223, 7, 3);
    DrawBadge(33, 321, 8, 3);
    DrawBadge(162, 359, 9, 3);
    DrawBadge(289, 418, 10, 1);
    DrawBadge(326, 307, 11, 1);
    DrawBadge(498, 299, 12, 2);
    DrawBadge(430, 409, 13, 2);
    DrawBadge(373, 517, 14, 2);
    DrawBadge(164, 481, 15, 1);
    DrawBadge(17, 459, 16, 1);
    DrawBadge(69, 600, 17, 3);
    DrawBadge(211, 606, 18, 3);
    DrawBadge(357, 617, 19, 2);
    DrawBadge(517, 577, 20, 2);
    DrawBadge(480, 705, 21, 2);
    DrawBadge(293, 713, 22, 3);
    DrawBadge(131, 713, 23, 3);
    DrawBadge(339, 823, 24, 5);
    DrawBadge(499, 811, 25, 4);

    var next = GetNewButton(game.ctx3, 535, 420 + game.padding, 100, 125, GetImg('btn_next_menu'), game.sounds.click);
    next.call = 'NextWorld';
    next.draw();
    game.buttons.push(next);

    game.ctx3.drawImage(GetImg('text_level'), 35, 25);

    var btn_shop = GetNewButton(game.ctx3, 8, game.height - 110, 100, 100, GetImg('btn_shop'), game.sounds.click);
    btn_shop.call = 'Shop';
    btn_shop.draw();
    game.buttons.push(btn_shop);
}

function NextWorld() {
    player.crash = false;
    player.landed = false;
    player.landedsplash = false;
    game.paused = false;
    game.play = false;
    game.intro = false;
    game.screen = 'menu';
    game.attempts = 0;
    game.world = 2;
    HideAd();

    FreeButtons();

    game.ctx3.clearRect(0, 0, game.width, game.height);
    game.ctx3.drawImage(GetImg('mars_darkside'), 0, game.padding);

    //Badges
    DrawBadge(23, 76, 26, 1);
    DrawBadge(139, 17, 27, 5);
    DrawBadge(270, 39, 28, 3);
    DrawBadge(432, 118, 29, 4);
    DrawBadge(300, 154, 30, 4);
    DrawBadge(150, 132, 31, 3);
    DrawBadge(28, 193, 32, 1);
    DrawBadge(53, 312, 33, 1);
    DrawBadge(210, 267, 34, 2);
    DrawBadge(364, 268, 35, 4);
    DrawBadge(503, 218, 36, 4);
    DrawBadge(515, 324, 37, 4);
    DrawBadge(350, 388, 38, 4);
    DrawBadge(192, 400, 39, 4);
    DrawBadge(135, 509, 40, 1);
    DrawBadge(262, 519, 41, 4);
    DrawBadge(389, 512, 42, 4);
    DrawBadge(510, 561, 43, 4);
    DrawBadge(419, 687, 44, 4);
    DrawBadge(277, 654, 45, 4);
    DrawBadge(156, 689, 46, 4);
    DrawBadge(39, 613, 47, 2);
    DrawBadge(17, 718, 48, 3);
    DrawBadge(121, 828, 49, 5);
    DrawBadge(296, 805, 50, 1);

    var prev = GetNewButton(game.ctx3, 5, 420 + game.padding, 100, 125, GetImg('btn_prev_menu'), game.sounds.click);
    prev.call = 'World';
    prev.draw();
    game.buttons.push(prev);

    var btn_shop = GetNewButton(game.ctx3, 532, game.height - 110, 100, 100, GetImg('btn_shop'), game.sounds.click);
    btn_shop.call = 'Shop';
    btn_shop.draw();
    game.buttons.push(btn_shop);
}

function DrawMenuScore(x, y, score) {
    var stars = GetImg('stars');
    game.ctx3.drawImage(
        stars,
	    0, 75,
	    225, 75,
	    x, y,
	    92, 30);
    game.ctx3.drawImage(
        stars,
	    0, 0,
	    (Math.ceil(score / 1000)) * 50 * 1.5, 75,
	    x, y,
	    ((Math.ceil(score / 1000)) / 3) * 92, 30);
}

function LevelGo(level) {
    game.level = level;
    SetLocalStorage('MARS_LEVEL', game.level);
    FreeButtons();
    DestroyImg();
    redolevel = false;
    Loading();
}

function Draw() {
    if (game.play) {
        game.ctx1.clearRect(0, 0, game.width, game.height);
        
        background.draw();
        sprites.draw();
        enemies.draw();
        UpdateGame(Frame() / 1000);
        Collisions();
        player.draw();
        if (level.wind) wind.draw();
        level.draw();
        rating.draw();
        SpriteCollisions();

    } else if (player.crash) {
        if (!player.over) {
            game.ctx1.clearRect(0, 0, game.width, game.height);
            background.draw();
            sprites.draw();
            enemies.draw();
            player.draw();
            if (player.bigbang != null) player.explosion();
            else player.over = true;
            if (level.wind) wind.draw();
            level.draw();
            game.ctx3.clearRect(0, 0, game.width, game.height);
            if (player.over) Crash2();
        }
    } else if (game.intro) {
		if (game.reload){
			if (!countdown.flagged){
				countdown.draw();
			}else{
				game.reload = false;
				game.intro = false;
				game.play = true;

				if (level.wind) {
					game.sounds.wind.snd.loop = true;
					game.sounds.wind.play();
				}

				left.draw();
				right.draw();
				pause.draw();

				DrawCoins();

				if (level.night) {
					deploy_flare.draw();
				}
				deploy_bomb.draw();

				if (level.night) {
					deploy_flare.draw();
				}
			}
			return;
		}
		game.ctx1.clearRect(0, 0, game.width, game.height);
		
        background.draw();
        sprites.draw();
        enemies.draw();
        player.x = player.panx + 295;
        player.draw();
        if (level.wind) wind.draw();
        level.draw();

        game.ctx1.drawImage(gameimages.destination, pad.x + player.panx + (pad.width / 2 - 31), pad.y + player.pany - 92);

        fade.draw();

        if (Date.now() - game.delay >= 850) {
            player.panx += player.panxstep * game.pandir;
            player.pany += player.panystep * game.panydir;
            player.y += player.panystep * game.panydir;
        }

        if ((game.pandir == 1 && player.panx >= 0) || (game.pandir == -1 && player.panx <= 0)) {
            if (!game.onboard) {
                OnBoard();
                return;
            }

            left.draw();
            right.draw();
            pause.draw();

            rating.draw();

            txtlevel.text = game.level;
            txtlevel.draw();

            DrawCoins();

            if (level.night) {
                DrawFlares();
                deploy_flare.draw();
            }
            DrawBombs();
            deploy_bomb.draw();

            player.panx = 0;
            player.pany = 0;
            player.x = 295;
            player.y = player.Y;
            game.intro = false;
            game.play = true;
        }
	} else if (player.landed) {
        game.ctx1.clearRect(0, 0, game.width, game.height);
        background.draw();
        sprites.draw();
        enemies.draw();
        player.draw();
        if (level.wind) wind.draw();
        level.draw();
        game.ctx3.clearRect(0, 0, game.width, game.height);

        var radians = (player.angle * 360) * (Math.PI / 180),
        distance = (Math.tan(radians)) * 30;
        player.x -= distance;

        if (Math.floor(Math.abs(distance)) == 0) {
            player.angle = 0;
        } else {
            if (player.angle > 0) player.angle -= 0.01;
            else player.angle += 0.01;
        }
        game.sounds.thrust.stop();
        player.l = false;
        player.r = false;

        if (Date.now() - game.delay >= 250) {
            player.landed = false;
            Landed();
        }
	} else if (game.shopping || game.shop) {
		ShopRedraw()
		if (game.shop) ShopDraw();
	} else if (player.landedsplash) {
        if (game.counter2 <= Math.ceil(rating.rate / 50) * 50) LandedSplash();
    } else if (game.menu) {
        game.ctx1.clearRect(0, 0, game.width, game.height);
        sprites.draw();

    }
}

function UpdateGame(rate) {
    if (player.vy != 0) {
        player.vy += game.gravity * rate;
        player.y += player.vy;
        player.y = player.y;

        if (player.vx > 0) player.vx -= game.friction * rate;
        else player.vx += game.friction * rate;
        player.x += player.vx + level.windSpeed;

    } else player.vx = 0;

    if (left.clicked && right.clicked) player.up(rate);
    else if (left.clicked) player.left(rate);
    else if (right.clicked) player.right(rate);

    ///////////////temp
    //if (37 in game.keysDown && 39 in game.keysDown) {
    //    player.up(rate);
    //} else {
    //    if (37 in game.keysDown) player.left(rate);
    //    else if (39 in game.keysDown) player.right(rate);
    //}
    ///////////////temp
}

function Collisions() {
    var y = player.y,
        y2 = player.y + player.height,
        x = player.x,
        x2 = player.x + player.width;

    if (!player.vy) {
        return;
    } else if ((player.vy <= game.landingv) && (Math.abs(player.angle) <= game.landingangle) &&
        (pad.x + player.panx <= x + 8 && x2 - 6 <= pad.x + pad.width + player.panx) &&
        (y2 >= pad.y + player.pany && y2 <= player.pany + pad.y + 10)) {

        if (man.y == 10000) {
            player.bigbang = null;
            Crash();
            return;
        }
        player.y = pad.y - player.height + 1 + player.pany;
        player.l = false;
        player.r = false;

        game.play = false;
        player.landed = true;
        game.delay = Date.now();
        return;
    } else if (game.ctx1.hasHit(x, y)) {
        Crash();
        return;
    } else if (player.pany <= -level.ground) {
        Crash();
        return;
    }

    player.x = 295;
    player.y = player.Y;

    player.pany -= player.vy;

    if (x >= 295) {
        player.panx -= player.vx + level.windSpeed;
        level.scrollspeed = 0.5;
    } else {
        player.panx -= player.vx + level.windSpeed;
        level.scrollspeed = 1.5;
    }
}

function SpriteCollisions() {
    if (!player.hit && enemies.enemy.length > 0) {
        var y = player.y,
            x = player.x,
            width = 25,
            height = 30;

        for (var i in enemies.enemy) {
            if (enemies.enemy[i].killed) continue;
            var ex1 = enemies.enemy[i].X,
                ey1 = enemies.enemy[i].Y,
                ewidth = enemies.enemy[i].halfwidth,
                eheight = enemies.enemy[i].halfheight,
                leftDist = (ex1 - ewidth) - (x + width),
                rightDist = (x - width) - (ex1 + ewidth),
                topDist = (ey1 - eheight) - (y + height),
                bottomDist = (y - height) - (ey1 + eheight);

            if (leftDist < 0 && rightDist < 0 && topDist < 0 && bottomDist < 0) {
                if (enemies.enemy[i] instanceof PowerUp) {
                    enemies.enemy[i].kill();
                    GetCollectSound();
                    rating.rate = 150;
                    break;
                } else if (enemies.enemy[i] instanceof Coin) {
                    enemies.enemy[i].kill();
                    GetCollectSound();
                    AddCoin();
                    break;
                } else if (enemies.enemy[i] instanceof Tornado) {
                    player.vx += player.vx > 0 ? 4 : -4;
                    player.hit = true;
                    rating.hit(game.rates.hit.tornado);
                    if (rating.rate <= 0) player.vy = 0.2;
                    break;
                } else if (enemies.enemy[i] instanceof Meteor) {
                    player.hit = true;
                    rating.hit(game.rates.hit.meteor);
                    player.vx += 1;
                    if (rating.rate <= 0) player.vy = 0.2;
                    break;
                }
            }
        }
    }
}

function Landed() {
    game.sounds.thrust.stop();
    game.sounds.thrust.reset();

    enemies.reset();
    sprites.reset();
    FreeButtons();

    if (level.wind) {
        game.sounds.wind.snd.loop = false;
        game.sounds.wind.snd.currentTime = 0;
        game.sounds.wind.stop();
    }
    game.screen = 'landed';
    game.reload = false;
    player.landed = false;
    player.clear();
	
	level.ary = [];
    //level.data = [];

    if (!game.review && game.landed > 3) {
        Review();
        return;
    }
	
    game.ctxTemp.drawImage(game.layer0, 0, 0);
    game.ctxTemp.drawImage(game.layer1, 0, 0);

    Blur(game.layerTemp, game.ctx0, 3, game.width, game.height);

    player.y = pad.y - player.height + player.pany;

    game.ctx1.clearRect(0, 0, game.width, game.height);
    game.ctx3.clearRect(0, 0, game.width, game.height);

    var score = Math.round(rating.rate < 0 ? 0 : rating.rate * 20);
    if (game.score[game.level - 1] == undefined) {
        game.score.push(score);
        game.share.message = score + '! New top score on #marslander level ' + game.level + '.';
    } else if (game.score[game.level - 1] <= score) {
        game.score[game.level - 1] = score;
        game.share.message = score + '! New top score on #marslander level ' + game.level + '.';
    } else {
        game.share.message = 'Scored' + score + ' on #marslander level ' + game.level + '. My best is ' + game.score[game.level - 1];
    }
    if (game.score[game.level] == undefined) {
        game.score.push(0.0);
    }
    SetLocalStorage('MARS_LEVEL', game.level + 1);
    SetLocalStorage('MARS_SCORE', game.score);
    
    game.counter2 = 0;

    var xpos = 320 - ((203 + (game.score[game.level - 1].toString().length * 25)) / 2);
    game.ctx1.drawImage(dialogimages.text_bestscore, xpos, game.height_quarter - 185);

    txtbestscore.text = game.score[game.level - 1];
    txtbestscore.x = xpos + 203;
    txtbestscore.y = game.height_quarter - 185;
    txtbestscore.draw();

    game.ctx1.drawImage(dialogimages.stars_landed, 0, 182, 467, 182, 89, game.height_quarter - 50, 467, 182);
		
    player.landedsplash = true;

    var next = GetNewButton(game.ctx1, 215, game.height_half - 102, 210, 262, dialogimages.btn_level_next, game.sounds.click);
    next.call = 'NextLevel';
    next.draw();
    game.buttons.push(next);

    var btnheight = game.height - game.adHeight - 165;
    //var btnheight = game.height_threequarter;
    var btn_redo = GetNewButton(game.ctx1, 56, btnheight, 93, 122, dialogimages.btn_redo, game.sounds.click);
    btn_redo.call = 'RedoLevel';
    btn_redo.draw();
    game.buttons.push(btn_redo);

    var btn_sound = GetNewButton(game.ctx1, 198, btnheight, 110, 122, dialogimages.btn_sound, game.sounds.click);
    btn_sound.call = 'SoundToggle';
    btn_sound.params = [198, btnheight, false];
    btn_sound.draw();
    game.buttons.push(btn_sound);

    var btn_share = GetNewButton(game.ctx1, 344, btnheight, 99, 125, dialogimages.btn_share, game.sounds.click);
    btn_share.call = 'ShareGame';
    btn_share.draw();
    game.buttons.push(btn_share);

    var btn_menu = GetNewButton(game.ctx1, 489, btnheight, 93, 122, dialogimages.btn_menu, game.sounds.click);
    btn_menu.call = 'LoadingMenu';
    btn_menu.draw();
    game.buttons.push(btn_menu);

    if (!game.sound) {
        game.ctx1.drawImage(
				dialogimages.btn_no_sound,
				0, 0,
				110, 100,
				198, btnheight,
				110, 100);
    }

    var btn_settings = GetNewButton(game.ctx1, 532, 0, 100, 100, dialogimages.btn_shop, game.sounds.click);
    btn_settings.call = 'Shop';
    btn_settings.draw();
    game.buttons.push(btn_settings);

    if (game.ads) {
        ShowAd();
    }

    game.landed += 1;
    
}

function ReinitLandedButtons() {
    var next = GetNewButton(game.ctx1, 215, game.height_half - 102, 210, 262, dialogimages.btn_level_next, game.sounds.click);
    next.call = 'NextLevel';
    next.active = true;
    game.buttons.push(next);

    var btnheight = game.height - game.adHeight - 165;
    var btn_redo = GetNewButton(game.ctx1, 56, btnheight, 93, 122, dialogimages.btn_redo, game.sounds.click);
    btn_redo.call = 'RedoLevel';
    btn_redo.active = true;
    game.buttons.push(btn_redo);

    var btn_sound = GetNewButton(game.ctx1, 198, btnheight, 110, 122, dialogimages.btn_sound, game.sounds.click);
    btn_sound.call = 'SoundToggle';
    btn_sound.params = [198, btnheight, false];
    btn_sound.active = true;
    game.buttons.push(btn_sound);

    var btn_share = GetNewButton(game.ctx1, 344, btnheight, 99, 125, dialogimages.btn_share, game.sounds.click);
    btn_share.call = 'ShareGame';
    btn_share.active = true;
    game.buttons.push(btn_share);

    var btn_menu = GetNewButton(game.ctx1, 489, btnheight, 93, 122, dialogimages.btn_menu, game.sounds.click);
    btn_menu.call = 'LoadingMenu';
    btn_menu.active = true;
    game.buttons.push(btn_menu);

    var btn_settings = GetNewButton(game.ctx1, 532, 0, 100, 100, dialogimages.btn_shop, game.sounds.click);
    btn_settings.call = 'Shop';
    btn_settings.active = true;
    game.buttons.push(btn_settings);
}

var landcount = 0;
function LandedSplash() {
    var value = 0,
        rate = 0;
    game.counter2 += 50 * game.rate;
    game.rate = Frame() / 1000;

    game.ctx3.clearRect(0, 0, game.width, game.height);

    if (game.counter2 <= Math.ceil(rating.rate / 50) * 50) {

        value = Math.round(game.counter2 * 20);

        txtscore.text = value.toString();
        txtscore.layer = game.ctx3;
        txtscore.x = 320 - ((value.toString().length * 53) / 2);
        txtscore.y = game.height_quarter - 140;
        txtscore.draw();

        rate = Math.ceil(game.counter2 / 50);
        if (rate == 1 && landcount > -1) {
            landcount += 1;
            if (landcount == 4) {
                game.ctx3.drawImage(dialogimages.stars_landed, 0, 0, 142, 182, -53, 7, 426, 546);
            } else if (landcount == 5) {
                game.ctx3.drawImage(dialogimages.stars_landed, 0, 0, 142, 182, 18, 118, 284, 364);
            } else if (landcount == 6) {
                game.ctx1.drawImage(dialogimages.stars_landed, 0, 0, 142, 182, 89, game.height_quarter - 50, 142, 182);
                landcount = -1;
                if (game.sound) {
                    game.sounds.twinkle.reset();
                    game.sounds.twinkle.play();
                }
            }
        } else if (rate == 2 && landcount > -2) {
            landcount += 1;
            if (landcount == 0) {
                game.ctx3.drawImage(dialogimages.stars_landed, 142, 0, 180, 182, 51, 7, 540, 546);
            } else if (landcount == 1) {
                game.ctx3.drawImage(dialogimages.stars_landed, 142, 0, 180, 182, 141, 118, 360, 364);
            } else if (landcount == 2) {
                game.ctx1.drawImage(dialogimages.stars_landed, 142, 0, 180, 182, 231, game.height_quarter - 50, 180, 182);
                landcount = -2
                if (game.sound) {
                    game.sounds.twinkle.reset();
                    game.sounds.twinkle.play();
                }
            }
        } else if (rate == 3 && landcount > -3) {
            landcount += 1;
            if (landcount == 0) {
                game.ctx3.drawImage(dialogimages.stars_landed, 322, 0, 144, 182, 267, 7, 432, 546);
            } else if (landcount == 1) {
                game.ctx3.drawImage(dialogimages.stars_landed, 322, 0, 144, 182, 339, 118, 288, 364);
            } else if (landcount == 2) {
                game.ctx1.drawImage(dialogimages.stars_landed, 322, 0, 144, 182, 411, game.height_quarter - 50, 144, 182);
                landcount = -4;
                if (game.sound) {
                    game.sounds.twinkle.reset();
                    game.sounds.twinkle.play();
                }
            }
        }
        
    } else {

        landcount = 0;
        player.landedsplash = false;

        value = Math.round(rating.rate < 0 ? 0 : rating.rate * 20);

        txtscore.text = value.toString();
        txtscore.layer = game.ctx1;
        txtscore.x = 320 - ((value.toString().length * 53) / 2);
        txtscore.y = game.height_quarter - 140;
        txtscore.draw();

    }

}

function Crash() {

    game.sounds.thrust.stop();
    game.play = false;
    player.crash = true;
    game.reload = false;
    game.sounds.explosion.play();
}
var skipheight = 15;
function Crash2() {

    enemies.reset();
    sprites.reset();
    FreeButtons();

    if (level.wind) {
        game.sounds.wind.snd.loop = false;
        game.sounds.wind.snd.currentTime = 0;
        game.sounds.wind.stop();
    }

    game.sounds.thrust.stop();
    player.crash = false;
    player.clear();
    game.screen = 'crash';

	level.ary = [];
    level.data = [];
	
    game.ctxTemp.drawImage(game.layer0, 0, 0);
    game.ctxTemp.drawImage(game.layer1, 0, 0);

    Blur(game.layerTemp, game.ctx0, 3, game.width, game.height);

    game.ctx1.clearRect(0, 0, game.width, game.height);
    game.ctx3.clearRect(0, 0, game.width, game.height);

    skipheight = 15;

    var images = [
        { image: dialogimages.text_crash, x: 119, y: game.height_quarter - 106 },
        { image: dialogimages.text_ouch, x: 118, y: game.height_quarter - 104 },
        { image: dialogimages.text_oops, x: 118, y: game.height_quarter - 104 }
    ], x = Math.floor(Math.random() * 3);

    if (man.y == 10000) {
        x = 2;
    }

    if ((pad.x + player.panx <= player.x + 8 && player.x + player.width - 6 <= pad.x + pad.width + player.panx) &&
        (player.y + player.height >= pad.y - 10 + player.pany && player.y + player.height <= pad.y + pad.height + 10 + player.pany)) {
        if (player.vy >= game.landingv) {
            if (game.height < 985) {
                game.ctx1.drawImage(dialogimages.text_toofast, 0, 0, 296, 218, 195, 88, 251, 185);
            } else {
                game.ctx1.drawImage(dialogimages.text_toofast, 172, game.height_quarter - 190);
            }
            skipheight += 30;
        } else if (Math.abs(player.angle) >= 0.025) {
            if (game.height < 985) {
                game.ctx1.drawImage(dialogimages.text_badangle, 0, 0, 403, 220, 151, 88, 339, 185);
            } else {
                game.ctx1.drawImage(dialogimages.text_badangle, 118, game.height_quarter - 190);
            }
            skipheight += 30;
        } else {
            game.ctx1.drawImage(images[x].image, images[x].x, images[x].y);
        }
    } else {
        game.ctx1.drawImage(images[x].image, images[x].x, images[x].y);
    }

    var redo = GetNewButton(game.ctx1, 215, game.height_half - 102, 210, 262, dialogimages.btn_level_redo, game.sounds.click);
    redo.call = 'RedoLevel';
    redo.draw();
    game.buttons.push(redo);

    var btnheight = game.height - game.adHeight - 165;

    var btn_sound = GetNewButton(game.ctx1, 97, btnheight, 110, 122, dialogimages.btn_sound, game.sounds.click);
    btn_sound.call = 'SoundToggle';
    btn_sound.params = [97, btnheight];
    btn_sound.draw();
    game.buttons.push(btn_sound);
    
    var btn_share = GetNewButton(game.ctx1, 273, btnheight, 99, 125, dialogimages.btn_share, game.sounds.click);
    btn_share.call = 'ShareGame';
    btn_share.draw();
    game.buttons.push(btn_share);
    
    game.share.message = '#marslander';
    game.share.image = game.splashImage;
    
    var btn_menu = GetNewButton(game.ctx1, 448, btnheight, 93, 122, dialogimages.btn_menu, game.sounds.click);
    btn_menu.call = 'LoadingMenu';
    btn_menu.draw();
    game.buttons.push(btn_menu);
    
    var btn_skip = GetNewButton(game.ctx1, 170, game.height_quarter + skipheight, 300, 80, dialogimages.text_skip, game.sounds.click);
    btn_skip.call = 'Skip';
    btn_skip.draw();
    game.buttons.push(btn_skip);
    
    if (!game.sound) {
        game.ctx1.drawImage(
            dialogimages.btn_no_sound,
            0, 0,
            110, 100,
            97, btnheight,
            110, 100);
    }

    var btn_settings = GetNewButton(game.ctx1, 532, 0, 100, 100, dialogimages.btn_shop, game.sounds.click);
    btn_settings.call = 'Shop';
    btn_settings.draw();
    game.buttons.push(btn_settings);
    
    if (game.ads) {
        ShowAd();
    }
		
}
function ReinitCrashButtons() {
    var redo = GetNewButton(game.ctx1, 215, game.height_half - 102, 210, 262, dialogimages.btn_level_redo, game.sounds.click);
    redo.call = 'RedoLevel';
    redo.active = true;
    game.buttons.push(redo);

    var btnheight = game.height - game.adHeight - 165;
    var btn_sound = GetNewButton(game.ctx1, 97, btnheight, 110, 122, dialogimages.btn_sound, game.sounds.click);
    btn_sound.call = 'SoundToggle';
    btn_sound.params = [97, btnheight];
    btn_sound.active = true;
    game.buttons.push(btn_sound);

    var btn_share = GetNewButton(game.ctx1, 273, btnheight, 99, 125, dialogimages.btn_share, game.sounds.click);
    btn_share.call = 'ShareGame';
    btn_share.active = true;
    game.buttons.push(btn_share);

    var btn_menu = GetNewButton(game.ctx1, 448, btnheight, 93, 122, dialogimages.btn_menu, game.sounds.click);
    btn_menu.call = 'LoadingMenu';
    btn_menu.active = true;
    game.buttons.push(btn_menu);

    var btn_skip = GetNewButton(game.ctx1, 170, game.height_quarter + skipheight, 300, 80, dialogimages.text_skip, game.sounds.click);
    btn_skip.call = 'Skip';
    btn_skip.active = true;
    game.buttons.push(btn_skip);

    var btn_settings = GetNewButton(game.ctx1, 532, 0, 100, 100, dialogimages.btn_shop, game.sounds.click);
    btn_settings.call = 'Shop';
    btn_settings.active = true;
    game.buttons.push(btn_settings);
}

function PauseGame() {
    game.paused = !game.paused;
    game.play = !game.play;

    if (game.paused) {
        game.ctx1.clearRect(0, 0, game.width, game.height);
        background.draw();
        sprites.draw();
        enemies.draw();
        player.draw();
		FreeButtons();

        game.screen = 'pause';

        if (level.wind) wind.draw();
        level.draw();

        game.ctxTemp.drawImage(game.layer0, 0, 0);
        game.ctxTemp.drawImage(game.layer1, 0, 0);

        Blur(game.layerTemp, game.ctx0, 3, game.width, game.height);

        game.ctx1.clearRect(0, 0, game.width, game.height);
        game.ctx3.clearRect(0, 0, game.width, game.height);

		var btnheight = game.height - game.adHeight - 165;

        game.ctx1.drawImage(dialogimages.text_paused, 120, game.height_quarter - 94);

        var pause_play = GetNewButton(game.ctx1, 215, game.height_half - 102, 210, 262, dialogimages.btn_splash_play, game.sounds.unpause);
		pause_play.call = 'PauseGame';
		pause_play.draw();
        game.buttons.push(pause_play);

        var pause_redo = GetNewButton(game.ctx1, 56, btnheight, 93, 122, dialogimages.btn_redo, game.sounds.click);
		pause_redo.call = 'RedoLevel';
		pause_redo.draw();
        game.buttons.push(pause_redo);

        var pause_sound = GetNewButton(game.ctx1, 198, btnheight, 110, 122, dialogimages.btn_sound, game.sounds.click);
		pause_sound.call = 'SoundToggle';
		pause_sound.params = [198, btnheight];
		pause_sound.draw();
        game.buttons.push(pause_sound);

        var pause_share = GetNewButton(game.ctx1, 344, btnheight, 99, 125, dialogimages.btn_share, game.sounds.click);
		pause_share.call = 'ShareGame';
		pause_share.draw();
        game.buttons.push(pause_share);

        var pause_menu = GetNewButton(game.ctx1, 489, btnheight, 93, 122, dialogimages.btn_menu, game.sounds.click);
		pause_menu.call = 'LoadingMenu';
		pause_menu.draw();
		game.buttons.push(pause_menu);

		game.share.message = '#marslander';
		game.share.image = game.splashImage;

		if (!game.sound) {
			game.ctx1.drawImage(
				dialogimages.btn_no_sound,
				0, 0,
				110, 100,
				198, btnheight,
				110, 100);
		} 

		var pause_settings = GetNewButton(game.ctx1, 532, 0, 100, 100, dialogimages.btn_shop, game.sounds.click);
		pause_settings.call = 'Shop';
		pause_settings.draw();
		game.buttons.push(pause_settings);

		if (game.ads) {
			ShowAd();
		}
		
        if (level.wind) {
            game.sounds.wind.snd.loop = false;
            game.sounds.wind.snd.currentTime = 0;
            game.sounds.wind.stop();
        }

        player.l = false;
        player.r = false;
        game.sounds.thrust.stop();

    } else {
        
        game.counter = 8;
        game.counter2 = 0;

        DrawBackground();
        game.ctx1.clearRect(0, 0, game.width, game.height);
        game.ctxTemp.clearRect(0, 0, game.width, game.height);
        HideAd();

        background.draw();
        sprites.draw();
        enemies.draw();
        player.draw();
		FreeButtons();
        game.screen = 'play';

        if (level.wind) {
            wind.draw();
            game.sounds.wind.play();
        }
        level.draw();
        rating.draw();
        
        txtlevel.text = game.level;
        txtlevel.draw();

        DrawCoins();

        if (level.night) {
            DrawFlares();
        }
        DrawBombs();
		
		left = GetNewButton(game.ctx3, 0, game.height - 250, 200, 200, gameimages.left, '', 0, 0, gameimages.left_on);
		game.buttons.push(left);
		right = GetNewButton(game.ctx3, 440, game.height - 250, 200, 200, gameimages.right, '', 0, 0, gameimages.right_on);
		game.buttons.push(right);
		pause = GetNewButton(game.ctx3, 520, 15, 150, 150, gameimages.pause, game.sounds.pause);
		pause.call = 'PauseGame';
		game.buttons.push(pause);
		
		deploy_bomb = GetNewButton(game.ctx3, 440, game.height - 375, 200, 125, gameimages.btn_bomb, '', 0, 0, gameimages.btn_bomb_on);
		deploy_bomb.call = 'DeployBomb';
		game.buttons.push(deploy_bomb);
		
		if (level.night){
			deploy_flare = GetNewButton(game.ctx3, 0, game.height - 375, 200, 125, gameimages.btn_flare, '', 0, 0, gameimages.btn_flare_on);
			deploy_flare.call = 'DeployFlare';
			game.buttons.push(deploy_flare);
		}

        game.play = false;
        game.intro = true;
        game.reload = true;
        countdown.init(270, game.height_quarter, game.ctx3, gameimages.text_count);
    }
}

function ReinitPauseButtons() {
    var btnheight = game.height - game.adHeight - 165;

    var pause_play = GetNewButton(game.ctx1, 215, game.height_half - 102, 210, 262, dialogimages.btn_splash_play, game.sounds.unpause);
    pause_play.call = 'PauseGame';
    pause_play.active = true;
    game.buttons.push(pause_play);

    var pause_redo = GetNewButton(game.ctx1, 56, btnheight, 93, 122, dialogimages.btn_redo, game.sounds.click);
    pause_redo.call = 'RedoLevel';
    pause_redo.active = true;
    game.buttons.push(pause_redo);

    var pause_sound = GetNewButton(game.ctx1, 198, btnheight, 110, 122, dialogimages.btn_sound, game.sounds.click);
    pause_sound.call = 'SoundToggle';
    pause_sound.params = [198, btnheight];
    pause_sound.active = true;
    game.buttons.push(pause_sound);

    var pause_share = GetNewButton(game.ctx1, 344, btnheight, 99, 125, dialogimages.btn_share, game.sounds.click);
    pause_share.call = 'ShareGame';
    pause_share.active = true;
    game.buttons.push(pause_share);

    var pause_menu = GetNewButton(game.ctx1, 489, btnheight, 93, 122, dialogimages.btn_menu, game.sounds.click);
    pause_menu.call = 'LoadingMenu';
    pause_menu.active = true;
    game.buttons.push(pause_menu);

    var pause_settings = GetNewButton(game.ctx1, 532, 0, 100, 100, dialogimages.btn_shop, game.sounds.click);
    pause_settings.call = 'Shop';
    pause_settings.active = true;
    game.buttons.push(pause_settings);
}

function OnBoard() {
    game.intro = false;

    game.ctxTemp.drawImage(game.layer0, 0, 0);
    game.ctxTemp.drawImage(game.layer1, 0, 0);

    Blur(game.layerTemp, game.ctx1, 3, game.width, game.height);

    LoadingOnBoard();

    if (level.wind) {
        game.sounds.wind.snd.loop = false;
        game.sounds.wind.snd.currentTime = 0;
        game.sounds.wind.stop();
    }

}

function OnBoardShow() {
    game.onboarding = true;

    OnBoard_1();
}

function OnBoard_1() {

    game.ctx3.drawImage(GetImg('onboard_1'), 0, game.height_half - 295);

    FreeButtons();

    var btn_gotit = GetNewButton(game.ctx3, 75, game.height_half + 180, 181, 100, null, '');
    btn_gotit.active = true;
    btn_gotit.call = 'OnBoardClose';
    game.buttons.push(btn_gotit);

    btn_next = GetNewButton(game.ctx3, 384, game.height_half + 180, 181, 100, null, '');
    btn_next.active = true;
    btn_next.call = 'OnBoard_2';
    game.buttons.push(btn_next);
}

function OnBoard_2() {

    game.ctx3.drawImage(GetImg('onboard_2'), 0, game.height_half - 295);

    FreeButtons();

    var btn_next = GetNewButton(game.ctx3, 384, game.height_half + 180, 181, 100, null, '');
    btn_next.active = true;
    btn_next.call = 'OnBoard_3';
    game.buttons.push(btn_next);

    var btn_prev = GetNewButton(game.ctx3, 75, game.height_half + 180, 181, 100, null, '');
    btn_prev.active = true;
    btn_prev.call = 'OnBoard_1';
    game.buttons.push(btn_prev);
}

function OnBoard_3() {

    game.ctx3.drawImage(GetImg('onboard_3'), 0, game.height_half - 295);

    FreeButtons();

    var btn_gotit = GetNewButton(game.ctx3, 384, game.height_half + 180, 181, 100, null, '');
    btn_gotit.active = true;
    btn_gotit.call = 'OnBoardClose';
    game.buttons.push(btn_gotit);

    var btn_prev = GetNewButton(game.ctx3, 75, game.height_half + 180, 181, 100, null, '');
    btn_prev.active = true;
    btn_prev.call = 'OnBoard_2';
    game.buttons.push(btn_prev);
}

function OnBoardClose() {
    game.onboard = true;
	game.onboarding = false;
	SetLocalStorage('MARS_ONBOARD', game.onboard);
    DestroyImg();
    game.ctx3.clearRect(0, 0, game.width, game.height);
    FreeButtons();

    left = GetNewButton(game.ctx3, 0, game.height - 250, 200, 200, gameimages.left, '', 0, 0, gameimages.left_on);
    game.buttons.push(left);
    right = GetNewButton(game.ctx3, 440, game.height - 250, 200, 200, gameimages.right, '', 0, 0, gameimages.right_on);
    game.buttons.push(right);
    pause = GetNewButton(game.ctx3, 520, 15, 150, 150, gameimages.pause, game.sounds.pause);
    pause.call = 'PauseGame';
    game.buttons.push(pause);

    deploy_bomb = GetNewButton(game.ctx3, 440, game.height - 375, 200, 125, gameimages.btn_bomb, '', 0, 0, gameimages.btn_bomb_on);
    deploy_bomb.call = 'DeployBomb';
    game.buttons.push(deploy_bomb);

    if (level.night) {
        deploy_flare = GetNewButton(game.ctx3, 0, game.height - 375, 200, 125, gameimages.btn_flare, '', 0, 0, gameimages.btn_flare_on);
        deploy_flare.call = 'DeployFlare';
        game.buttons.push(deploy_flare);
    }

    if (level.wind) {
        game.sounds.wind.play();
    }
    game.intro = true;
}

var review_rating = 0;

function Review() {
    HideAd();
    FreeButtons();
    LoadingReview();
}
var star1, star2, star3, star4, star5;
function ReviewShow() {
    DrawTile(game.ctx3, GetImg('bg_space'));

    var btnheight = game.height - game.adHeight - 165;
    var ypos = Math.round(btnheight / 2);
    
    game.ctx3.drawImage(GetImg('review'), 0, 0, 640, 490, 0, ypos - 245, 640, 490);
    game.ctx3.drawImage(GetImg('review'), 0, 490, 640, 100, 0, btnheight + 90, 640, 100);

    game.ctx3.drawImage(GetImg('btn_review'),
			            0, 0,
			            100, 100,
                        82, btnheight,
			            100, 100);
    
    var btn_never = GetNewButton(game.ctx3, 42, btnheight, 181, 140, null, '');
    btn_never.active = true;
    btn_never.call = 'ReviewNever';
    game.buttons.push(btn_never);

    game.ctx3.drawImage(GetImg('btn_review'),
			            100, 0,
			            100, 100,
                        273, btnheight,
			            100, 100);
    
    var btn_later = GetNewButton(game.ctx3, 233, btnheight, 181, 140, null, '');
    btn_later.active = true;
    btn_later.call = 'ReviewLater';
    game.buttons.push(btn_later);

    game.ctx3.drawImage(GetImg('btn_review'),
			            200, 0,
			            100, 100,
                        464, btnheight,
			            100, 100);
    
    var btn_submit = GetNewButton(game.ctx3, 424, btnheight, 181, 140, null, '');
    btn_submit.active = true;
    btn_submit.call = 'ReviewSubmit';
    game.buttons.push(btn_submit);

    game.ctx3.fillStyle = '#000';

    star1 = GetNewButton(game.ctx3, 95, ypos + 90, 90, 90, GetImg('stars'), '', 0, 75, null, 75, 75);
    star1.call = 'ReviewRate';
    star1.params = [1];
    star1.draw();
    game.buttons.push(star1);

    star2 = GetNewButton(game.ctx3, 185, ypos + 90, 90, 90, GetImg('stars'), '', 0, 75, null, 75, 75);
    star2.call = 'ReviewRate';
    star2.params = [2];
    star2.draw();
    game.buttons.push(star2);

    star3 = GetNewButton(game.ctx3, 275, ypos + 90, 90, 90, GetImg('stars'), '', 0, 75, null, 75, 75);
    star3.call = 'ReviewRate';
    star3.params = [3];
    star3.draw();
    game.buttons.push(star3);

    star4 = GetNewButton(game.ctx3, 365, ypos + 90, 90, 90, GetImg('stars'), '', 0, 75, null, 75, 75);
    star4.call = 'ReviewRate';
    star4.params = [4];
    star4.draw();
    game.buttons.push(star4);

    star5 = GetNewButton(game.ctx3, 455, ypos + 90, 90, 90, GetImg('stars'), '', 0, 75, null, 75, 75);
    star5.call = 'ReviewRate';
    star5.params = [5];
    star5.draw();
    game.buttons.push(star5);
}

function ReviewRate(rate) {
    review_rating = rate;
    
    var btnheight = game.height - game.adHeight - 165;
    var ypos = Math.round(btnheight / 2);
    game.ctx3.clearRect(95, ypos + 90, 450, 90);
    game.ctx3.fillStyle = '#000';
    game.ctx3.fillRect(95, ypos + 90, 450, 90);

    star1.sy = 75;
    star2.sy = 75;
    star3.sy = 75;
    star4.sy = 75;
    star5.sy = 75;

    if (rate == 1) {
        star1.sy = 0;
    } else if (rate == 2) {
        star1.sy = 0;
        star2.sy = 0;
    } else if (rate == 3) {
        star1.sy = 0;
        star2.sy = 0;
        star3.sy = 0;
    } else if (rate == 4) {
        star1.sy = 0;
        star2.sy = 0;
        star3.sy = 0;
        star4.sy = 0;
    } else if (rate == 5) {
        star1.sy = 0;
        star2.sy = 0;
        star3.sy = 0;
        star4.sy = 0;
        star5.sy = 0;
    }

    star1.draw();
    star2.draw();
    star3.draw();
    star4.draw();
    star5.draw();
}

function ReviewNever() {
    game.review = true;
    SetLocalStorage('MARS_REVIEW', game.review);
    ReviewClose();
}

function ReviewLater() {
    ReviewClose();
}

function ReviewSubmit() {
    game.review = true;
    SetLocalStorage('MARS_REVIEW', game.review);
    game.coin += 500;
    SetLocalStorage('MARS_COIN', game.coin);
    if (review_rating >= 4) {
        try {
			window.open("https://play.google.com/store/apps/details?id=com.smashola.mars_lander", "_system");
        } catch (e) { }
    }
    ReviewClose();
}

function ReviewClose() {
    DestroyImg();
    game.ctx3.clearRect(0, 0, game.width, game.height);
    game.landed = 0;
    Landed();
}

function Shop() {
    HideAd();
    FreeButtons();
    DestroyImg();
    LoadingShop();
}

var shop_index = 8,
    shop_canvas,
    shop_ctx,
    shop_dir = 1,
    shop_x = 0,
	shop_y = 100,
	shop_bg, shop_bgctx,
    shop_board,
    shop_title_y = 0,
	shop_can1, shop_can2, shop_can3, shop_can4, shop_can5, shop_can6, shop_can7, shop_can8;
var shop_close, shop_next, shop_previous, btn_purchase;
var shopads = false;

function ShowShop() {
    var width,
		tempcan = CreateOffScreenCanvas(200, 30),
		tempctx = tempcan.getContext('2d');
		
	shopads = game.ads;
	
	shop_bg = CreateOffScreenCanvas(game.width, game.height),
	shop_bgctx = shop_bg.getContext('2d');

    var ctx1 = shop_can1.getContext('2d');
    ctx1.drawImage(GetImg('shop_1'), 0, 0);

    if (!game.ads) {
        ctx1.fillStyle = '#0099FF';
        ctx1.fillRect(435, 15, 56, 56);
    }
    if (game.bombcap != 3) {
        ctx1.drawImage(GetImg('btn_bought'), 290, 318);
    } else {
        tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
        txtshop.text = game.productPrice_bombcap;
        txtshop.layer = tempctx;
        width = txtshop.overalwidth();
        if (width > 200) tempcan.width = width;
        txtshop.x = (tempcan.width / 2) - (width / 2);
        txtshop.draw();
        ctx1.drawImage(tempcan, 0, 0, tempcan.width, 30, 220, 328, 200, 30);
        tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
    }


    var ctx2 = shop_can2.getContext('2d');
    ctx2.drawImage(GetImg('shop_2'), 0, 0);
    if (!game.ads) {
        ctx2.fillStyle = '#000000';
        ctx2.fillRect(435, 15, 56, 56);
    }
    if (game.flarecap != 5) {
        ctx2.drawImage(GetImg('btn_bought'), 290, 318);
    } else {
        tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
        txtshop.text = game.productPrice_flarecap;
        txtshop.layer = tempctx;
        width = txtshop.overalwidth();
        if (width > 200) tempcan.width = width;
        txtshop.x = (tempcan.width / 2) - (width / 2);
        txtshop.draw();
        ctx2.drawImage(tempcan, 0, 0, tempcan.width, 30, 220, 328, 200, 30);
        tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
    }

    var ctx3 = shop_can3.getContext('2d');
    ctx3.drawImage(GetImg('shop_3'), 0, 0);
    if (!game.ads) {
        ctx3.fillStyle = '#0099FF';
        ctx3.fillRect(435, 15, 56, 56);
    }
    if (game.shields) {
        ctx3.drawImage(GetImg('btn_bought'), 290, 318);
    } else {
        tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
        txtshop.text = game.productPrice_shields;
        txtshop.layer = tempctx;
        width = txtshop.overalwidth();
        if (width > 200) tempcan.width = width;
        txtshop.x = (tempcan.width / 2) - (width / 2);
        txtshop.draw();
        ctx3.drawImage(tempcan, 0, 0, tempcan.width, 30, 220, 328, 200, 30);
        tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
    }
    var ctx4 = shop_can4.getContext('2d');
    ctx4.drawImage(GetImg('shop_4'), 0, 0);
    if (!game.ads) {
        ctx4.fillStyle = '#8EEB62';
        ctx4.fillRect(435, 15, 56, 56);
    }	
    if (game.fuel) {
        ctx4.drawImage(GetImg('btn_bought'), 290, 318);
    } else {
        tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
        txtshop.text = game.productPrice_fuel;
        txtshop.layer = tempctx;
        width = txtshop.overalwidth();
        if (width > 200) tempcan.width = width;
        txtshop.x = (tempcan.width / 2) - (width / 2);
        txtshop.draw();
        ctx4.drawImage(tempcan, 0, 0, tempcan.width, 30, 220, 328, 200, 30);
    }

    var ctx5 = shop_can5.getContext('2d');
    ctx5.drawImage(GetImg('shop_5'), 0, 0);
    if (game.type == 1){
        ctx5.drawImage(GetImg('btn_bought'), 290, 318);
    } else{
        ctx5.drawImage(GetImg('text_select'), 270, 330);
    }

    var ctx6 = shop_can6.getContext('2d');
    ctx6.drawImage(GetImg('shop_6'), 0, 0);
    if (game.lander) {
        if (game.type == 2){
            ctx6.drawImage(GetImg('btn_bought'), 290, 318);
        } else{
            ctx6.drawImage(GetImg('text_select'), 270, 328);
        }
    } else {
        tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
        txtshop.text = game.productPrice_lander;
        txtshop.layer = tempctx;
        width = txtshop.overalwidth();
        if (width > 200) tempcan.width = width;
        txtshop.x = (tempcan.width / 2) - (width / 2);
        txtshop.draw();
        ctx6.drawImage(tempcan, 0, 0, tempcan.width, 30, 220, 328, 200, 30);
    }

    var ctx7 = shop_can7.getContext('2d');
    ctx7.drawImage(GetImg('shop_7'), 0, 0);
    if (!game.ads) {
        ctx7.fillStyle = '#0099FF';
        ctx7.fillRect(435, 15, 56, 56);
    }
    if (game.comboa) {
        ctx7.drawImage(GetImg('btn_bought'), 290, 318);
    } else {
        tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
        txtshop.text = game.productPrice_comboa;
        txtshop.layer = tempctx;
        width = txtshop.overalwidth();
        if (width > 200) tempcan.width = width;
        txtshop.x = (tempcan.width / 2) - (width / 2);
        txtshop.draw();
        ctx7.drawImage(tempcan, 0, 0, tempcan.width, 30, 220, 328, 200, 30);
    }

    var ctx8 = shop_can8.getContext('2d');
    ctx8.drawImage(GetImg('shop_8'), 0, 0);
    if (!game.ads) {
        ctx8.fillStyle = '#000000';
        ctx8.fillRect(435, 15, 56, 56);
    }	
    if (game.combob) {
        ctx8.drawImage(GetImg('btn_bought'), 290, 318);
    } else {
        tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
        txtshop.text = game.productPrice_combob;
        txtshop.layer = tempctx;
        width = txtshop.overalwidth();
        if (width > 200) tempcan.width = width;
        txtshop.x = (tempcan.width / 2) - (width / 2);
        txtshop.draw();
        ctx8.drawImage(tempcan, 0, 0, tempcan.width, 30, 220, 328, 200, 30);
    }

    btn_purchase = GetNewButton(game.ctx3, 200, 300, 200, 90, GetImg('btn_buy'), game.sounds.click);
    btn_purchase.active = true;
    btn_purchase.call = 'Buy';
    btn_purchase.params = [shop_index];
    game.buttons.push(btn_purchase);

    DrawTile(shop_bgctx, GetImg('shop_background'));
	game.ctx3.drawImage(shop_bg, 0, 0);

	shop_y = Math.round(((game.height - 465 - 100) - 400) / 2) + 100;
    if (shop_index == 1) {
        game.ctx3.drawImage(shop_can1, 0, shop_y, 640, 400);
    } else if (shop_index == 2) {
        game.ctx3.drawImage(shop_can2, 0, shop_y, 640, 400);
    } else if (shop_index == 3) {
        game.ctx3.drawImage(shop_can3, 0, shop_y, 640, 400);
    } else if (shop_index == 4) {
        game.ctx3.drawImage(shop_can4, 0, shop_y, 640, 400);
    } else if (shop_index == 5) {
        game.ctx3.drawImage(shop_can5, 0, shop_y, 640, 400);
    } else if (shop_index == 6) {
        game.ctx3.drawImage(shop_can6, 0, shop_y, 640, 400);
    } else if (shop_index == 7) {
        game.ctx3.drawImage(shop_can7, 0, shop_y, 640, 400);
    }

    btn_purchase.x = 210;
    btn_purchase.y = shop_y + 300;
    btn_purchase.width = 220;
    btn_purchase.height = 90;

    shop_close = GetNewButton(game.ctx3, 540, 0, 100, 100, GetImg('btn_close'), game.sounds.click);
    shop_close.call = 'CloseShop';
    shop_close.draw();
    game.buttons.push(shop_close);

    shop_next = GetNewButton(game.ctx3, 535, shop_y + 125, 100, 125, GetImg('btn_next'), '');
    shop_next.call = 'ShopNext';
    shop_next.draw();
    game.buttons.push(shop_next);

    shop_previous = GetNewButton(game.ctx3, 5, shop_y + 125, 100, 125, GetImg('btn_prev'), '');
    shop_previous.call = 'ShopPrev';
    shop_previous.draw();
    game.buttons.push(shop_previous);

    if (game.height == 960) {
        shop_title_y = 31;
    } else {
        shop_title_y = shop_y - 100;
        if (shop_title_y < 31) shop_title_y = 31;
    }

    game.ctx3.drawImage(GetImg('text_upgrades'), 186, shop_title_y);

	////////////////////
	
	shop_board = CreateOffScreenCanvas(game.width, 435);
	var shop_boardctx = shop_board.getContext('2d');
	
    var btn_restore = GetNewButton(game.ctx3, 208, game.height - 118, 225, 100, GetImg('btn_restore'), game.sounds.click);
    btn_restore.call = 'Restore';
    btn_restore.active = true;
    game.buttons.push(btn_restore);
	shop_boardctx.drawImage(GetImg('btn_restore'), 208, 317);

    shop_boardctx.drawImage(GetImg('shop_board'), 26, 0);

    var btn_coin1 = GetNewButton(game.ctx3, 410, game.height - 435, 200, 90, GetImg('btn_buy'), game.sounds.click);
    btn_coin1.call = 'Buy';
	btn_coin1.active = true;
    btn_coin1.params = [9];
    game.buttons.push(btn_coin1);
	shop_boardctx.drawImage(GetImg('btn_buy'), 410, 0);
	
    tempcan.width = 156;

    tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
    txtshop.text = game.productPrice_coin1;
    txtshop.layer = tempctx;
    width = txtshop.overalwidth();
    if (width > 156) tempcan.width = width;
    txtshop.x = (tempcan.width / 2) - (width / 2);
    txtshop.draw();
    shop_boardctx.drawImage(tempcan, 0, 0, tempcan.width, 30, 431, 28, 156, 30);

    var btn_coin2 = GetNewButton(game.ctx3, 410, game.height - 327, 200, 90, GetImg('btn_buy'), game.sounds.click);
    btn_coin2.call = 'Buy';
    btn_coin2.params = [10];
    btn_coin2.active = true;
    game.buttons.push(btn_coin2);
	shop_boardctx.drawImage(GetImg('btn_buy'), 410, 108);

    tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
    txtshop.text = game.productPrice_coin2;
    txtshop.layer = tempctx;
    width = txtshop.overalwidth();
    if (width > 156) tempcan.width = width;
    txtshop.x = (tempcan.width / 2) - (width / 2);
    txtshop.draw();
    shop_boardctx.drawImage(tempcan, 0, 0, tempcan.width, 30, 431, 136, 156, 30);

    if (game.ads) {
        var btn_noad = GetNewButton(game.ctx3, 410, game.height - 220, 200, 90, GetImg('btn_buy'), game.sounds.click);
        btn_noad.call = 'Buy';
        btn_noad.params = [11];
        btn_noad.active = true;
        game.buttons.push(btn_noad);
		shop_boardctx.drawImage(GetImg('btn_buy'), 410, 215);
		
        tempctx.clearRect(0, 0, tempcan.width, tempcan.height);
        txtshop.text = game.productPrice_noad;
        txtshop.layer = tempctx;
        width = txtshop.overalwidth();
        if (width > 156) tempcan.width = width;
        txtshop.x = (tempcan.width / 2) - (width / 2);
        txtshop.draw();
        shop_boardctx.drawImage(tempcan, 0, 0, tempcan.width, 30, 431, 243, 156, 30);

    } else {
        shop_boardctx.drawImage(GetImg('btn_bought'), 480, 235);
    }
	
	game.ctx3.drawImage(shop_board, 0, game.height - 435);

    shop_canvas = CreateOffScreenCanvas(1280, 400);
    shop_ctx = shop_canvas.getContext('2d');
	
	game.shopping = true;
	ShopNext();
}

function ShopUpdate() {
    if (game.bombcap != 3) {
        var ctx1 = shop_can1.getContext('2d');
        ctx1.drawImage(GetImg('shop_1'), 211, 311, 215, 70, 211, 311, 215, 70);
        ctx1.drawImage(GetImg('btn_bought'), 290, 318);
    }
    if (game.flarecap != 5) {
        var ctx2 = shop_can2.getContext('2d');
        ctx2.drawImage(GetImg('shop_2'), 211, 311, 215, 70, 211, 311, 215, 70);
        ctx2.drawImage(GetImg('btn_bought'), 290, 318);
    }
    if (game.shields) {
        var ctx3 = shop_can3.getContext('2d');
        ctx3.drawImage(GetImg('shop_3'), 211, 311, 215, 70, 211, 311, 215, 70);
        ctx3.drawImage(GetImg('btn_bought'), 290, 318);
    }
    if(game.fuel) {
        var ctx4 = shop_can4.getContext('2d');
        ctx4.drawImage(GetImg('shop_4'), 211, 311, 215, 70, 211, 311, 215, 70);
        ctx4.drawImage(GetImg('btn_bought'), 290, 318);
    }
    var ctx5 = shop_can5.getContext('2d');
    ctx5.drawImage(GetImg('shop_5'), 211, 311, 215, 70, 211, 311, 215, 70);
    if (game.type == 1) {
        ctx5.drawImage(GetImg('btn_bought'), 290, 318);
    } else {
        ctx5.drawImage(GetImg('text_select'), 270, 330);
    }
    if (game.lander) {
        var ctx6 = shop_can6.getContext('2d');
        ctx6.drawImage(GetImg('shop_6'), 211, 311, 215, 70, 211, 311, 215, 70);
        if (game.type == 2) {
            ctx6.drawImage(GetImg('btn_bought'), 290, 318);
        } else {
            ctx6.drawImage(GetImg('text_select'), 270, 328);
        }
    }
    if (game.comboa) {
        var ctx7 = shop_can7.getContext('2d');
        ctx7.drawImage(GetImg('shop_7'), 211, 311, 215, 70, 211, 311, 215, 70);
        ctx7.drawImage(GetImg('btn_bought'), 290, 318);
    }
    if (game.combob) {
        var ctx8 = shop_can8.getContext('2d');
        ctx8.drawImage(GetImg('shop_8'), 211, 311, 215, 70, 211, 311, 215, 70);
        ctx8.drawImage(GetImg('btn_bought'), 290, 318);
    }
    if (!game.ads) {
        var shop_boardctx = shop_board.getContext('2d');
        shop_boardctx.clearRect(410, 215, 200, 90);
        shop_boardctx.drawImage(GetImg('shop_board'), 384, 215, 200, 90, 410, 215, 200, 90);
        shop_boardctx.drawImage(GetImg('btn_bought'), 480, 235);

        var ctx = shop_can1.getContext('2d');
        ctx.fillStyle = '#0099FF';
        ctx.fillRect(435, 15, 56, 56);

        ctx = shop_can2.getContext('2d');
        ctx.fillStyle = '#000000';
        ctx.fillRect(435, 15, 56, 56);

        ctx = shop_can3.getContext('2d');
        ctx.fillStyle = '#0099FF';
        ctx.fillRect(435, 15, 56, 56);

        ctx = shop_can4.getContext('2d');
        ctx.fillStyle = '#8EEB62';
        ctx.fillRect(435, 15, 56, 56);

        ctx = shop_can7.getContext('2d');
        ctx.fillStyle = '#0099FF';
        ctx.fillRect(435, 15, 56, 56);

        ctx = shop_can8.getContext('2d');
        ctx.fillStyle = '#000000';
        ctx.fillRect(435, 15, 56, 56);
    }
}

function ShopRedraw() {
    
	game.ctx3.clearRect(0, 0, game.width, game.height);
	game.ctx3.drawImage(shop_bg, 0, 0);

	shop_close.draw();
	shop_next.draw();
	shop_previous.draw();
    game.ctx3.drawImage(GetImg('text_upgrades'), 186, shop_title_y);
	game.ctx3.drawImage(shop_board, 0, game.height - 435);
	
    if (!game.shop) {
		if (shop_index == 1) {
			game.ctx3.drawImage(shop_can1, 0, shop_y, 640, 400);
		} else if (shop_index == 2) {
			game.ctx3.drawImage(shop_can2, 0, shop_y, 640, 400);
		} else if (shop_index == 3) {
			game.ctx3.drawImage(shop_can3, 0, shop_y, 640, 400);
		} else if (shop_index == 4) {
			game.ctx3.drawImage(shop_can4, 0, shop_y, 640, 400);
		} else if (shop_index == 5) {
			game.ctx3.drawImage(shop_can5, 0, shop_y, 640, 400);
        } else if (shop_index == 6) {
            game.ctx3.drawImage(shop_can6, 0, shop_y, 640, 400);
        } else if (shop_index == 7) {
            game.ctx3.drawImage(shop_can7, 0, shop_y, 640, 400);
        } else if (shop_index == 8) {
            game.ctx3.drawImage(shop_can8, 0, shop_y, 640, 400);
        }
	}

    if (coinup_shop.y != 0) {
        coinup_shop.count += 1;
        if (coinup_shop.count > 2) {
            coinup_shop.count = 0;
            if (coinup_shop.index < 5) {
                coinup_shop.index += 1;
                game.ctx3.drawImage(GetImg('coinup_shop'),
                    coinup_shop.index * 67, 0,
                    67, 170,
                    coinup_shop.x, coinup_shop.y,
                    67, 170);
            }else {
                coinup_shop.y = 0;
                coinup_shop.index = 0;
                coinup_shop.count = 0;
            }
        }    
    }
}

function ShopDraw() {

    game.rate = Frame() / 1000;
    game.ctx3.drawImage(shop_canvas, shop_x, shop_y);

    shop_x += game.rate * 2000 * shop_dir;

    if (shop_dir < 0 && shop_x <= -640) {
        game.shop = false;
        game.ctx3.drawImage(shop_canvas, -640, shop_y);
        shop_next.call = 'ShopNext';
        shop_previous.call = 'ShopPrev';
    } else if (shop_dir > 0 && shop_x >= 0) {
        game.shop = false;
        game.ctx3.drawImage(shop_canvas, 0, shop_y);
        shop_next.call = 'ShopNext';
        shop_previous.call = 'ShopPrev';
    }

    if (!game.shop) {
        btn_purchase.call = 'Buy';
        btn_purchase.params = [shop_index];
        btn_purchase.active = true;
    }

    shop_next.draw();
    shop_previous.draw();

}

function ShopNext() {
    shop_ctx.clearRect(0, 0, 1280, 400);
    if (shop_index == 1) {
        shop_ctx.drawImage(shop_can1, 0, 0);
        shop_ctx.drawImage(shop_can2, 640, 0);
    } else if (shop_index == 2) {
        shop_ctx.drawImage(shop_can2, 0, 0);
        shop_ctx.drawImage(shop_can3, 640, 0);
    } else if (shop_index == 3) {
        shop_ctx.drawImage(shop_can3, 0, 0);
        shop_ctx.drawImage(shop_can4, 640, 0);
    } else if (shop_index == 4) {
        shop_ctx.drawImage(shop_can4, 0, 0);
        shop_ctx.drawImage(shop_can5, 640, 0);
    } else if (shop_index == 5) {
        shop_ctx.drawImage(shop_can5, 0, 0);
        shop_ctx.drawImage(shop_can6, 640, 0);
    } else if (shop_index == 6) {
        shop_ctx.drawImage(shop_can6, 0, 0);
        shop_ctx.drawImage(shop_can7, 640, 0);
    } else if (shop_index == 7) {
        shop_ctx.drawImage(shop_can7, 0, 0);
        shop_ctx.drawImage(shop_can8, 640, 0);
    } else if (shop_index == 8) {
        shop_ctx.drawImage(shop_can8, 0, 0);
        shop_ctx.drawImage(shop_can1, 640, 0);
    }
    btn_purchase.active = false;

    shop_index++;
    if (shop_index > 8) shop_index = 1;

    shop_dir = -1;
    shop_x = 0;

    shop_previous.call = '';
    shop_next.call = '';

    game.shop = true;

    if (game.sound) {
        game.sounds.slide.play();
    }
}

function ShopPrev() {
    shop_ctx.clearRect(0, 0, 1280, 400);
    if (shop_index == 1) {
        shop_ctx.drawImage(shop_can8, 0, 0);
        shop_ctx.drawImage(shop_can1, 640, 0);
    } else if (shop_index == 2) {
        shop_ctx.drawImage(shop_can1, 0, 0);
        shop_ctx.drawImage(shop_can2, 640, 0);
    } else if (shop_index == 3) {
        shop_ctx.drawImage(shop_can2, 0, 0);
        shop_ctx.drawImage(shop_can3, 640, 0);
    } else if (shop_index == 4) {
        shop_ctx.drawImage(shop_can3, 0, 0);
        shop_ctx.drawImage(shop_can4, 640, 0);
    } else if (shop_index == 5) {
        shop_ctx.drawImage(shop_can4, 0, 0);
        shop_ctx.drawImage(shop_can5, 640, 0);
    } else if (shop_index == 6) {
        shop_ctx.drawImage(shop_can5, 0, 0);
        shop_ctx.drawImage(shop_can6, 640, 0);
    } else if (shop_index == 7) {
        shop_ctx.drawImage(shop_can6, 0, 0);
        shop_ctx.drawImage(shop_can7, 640, 0);
    } else if (shop_index == 8) {
        shop_ctx.drawImage(shop_can7, 0, 0);
        shop_ctx.drawImage(shop_can8, 640, 0);
    }
    btn_purchase.active = false;

    shop_index--;
    if (shop_index < 1) shop_index = 8;

    shop_dir = 1;
    shop_x = -640;

    shop_previous.call = '';
    shop_next.call = '';

    game.shop = true;

    if (game.sound) {
        game.sounds.slide.play();
    }
}

function CloseShop() {
	game.shopping = false;
    game.shop = false;

    FreeButtons();
    DestroyImg();
    
    game.ctx3.drawImage(bg_loading, 0, 0);

    if (!game.reload) game.ctx3.clearRect(0, 0, game.width, game.height);

    if (game.menu) {
        LoadingMenu();
    } else if (blnReloadLevel) {
        blnReloadLevel = false;
        game.paused = false;
        game.reload = false;
        game.intro = false;
        RedoLevel();
    } else if (game.reload) {
        ReloadNow(reloadtype);
    } else {
        if (game.screen == 'pause') {
            ReinitPauseButtons();
        } else if (game.screen == 'landed') {
            ReinitLandedButtons();
        } else if (game.screen == 'crash') {
            ReinitCrashButtons();
        }
        
    }
}

function ReloadNow(type) {
    if (level.wind) {
        game.sounds.wind.snd.loop = false;
        game.sounds.wind.snd.currentTime = 0;
        game.sounds.wind.stop();
    }

    player.l = false;
    player.r = false;

    FreeButtons();

    for (var i = sprites.sprite.length - 1; i >= 0; i--)
        if (sprites.sprite[i] instanceof Reload)
            sprites.sprite.splice(i, 1);

    if (game.sound) game.sounds.thrust.stop();

    reloadtype = type;
    LoadingReload();

    game.ctx1.clearRect(0, 0, game.width, game.height);
    background.draw();
    sprites.draw();
    enemies.draw();
    player.draw();

    if (level.wind) wind.draw();
    level.draw();

    game.ctxTemp.drawImage(game.layer0, 0, 0);
    game.ctxTemp.drawImage(game.layer1, 0, 0);

    Blur(game.layerTemp, game.ctx1, 3, game.width, game.height);

}

var reloadtype = 1;
function ReloadShow() {
    game.ctx3.clearRect(0, 0, game.width, game.height);

    if (game.ads) {
        ShowAd();
    }

    var y = Math.round(game.height / 2) - 284;
    var x = 61;
    game.ctx3.drawImage(GetImg('reloadbg'), x, y);

    game.ctx3.drawImage(gameimages.coins, 20, 24);
    game.ctx3.drawImage(GetImg('reload_x'), 0, 0, 61, 66, 97, 42, 23, 26);
    txtcoincount.text = game.coin;
    txtcoincount.draw();

    var btn_reloadbuy = GetNewButton(game.ctx3, x + 144, y + 435, 230, 75, null, '');
    btn_reloadbuy.active = true;
    game.buttons.push(btn_reloadbuy);

    if (reloadtype == 1) {
        game.ctx3.drawImage(GetImg('reload_bomb'), x + 111, y + 156);
        btn_reloadbuy.call = 'BuyBombs';
    } else if (reloadtype == 2) {
        game.ctx3.drawImage(GetImg('reload_flare'), x + 111, y + 156);
        btn_reloadbuy.call = 'BuyFlares';
    }

    game.ctx3.beginPath();
    game.ctx3.arc(578, y + 5, 18, 0, 2 * Math.PI);
    if (levelimages.background.src.indexOf('blue') != -1) {
        game.ctx3.fillStyle = '#0099FF';
    } else if (levelimages.background.src.indexOf('green') != -1) {
        game.ctx3.fillStyle = '#8EEB62';
    } else if (levelimages.background.src.indexOf('brown') != -1) {
        game.ctx3.fillStyle = '#8E2A1B';
    } else if (levelimages.background.src.indexOf('night') != -1 || levelimages.background.src.indexOf('white') != -1) {
        game.ctx3.fillStyle = '#000';
    }
    game.ctx3.fill();

    var btn_reloadclose = GetNewButton(game.ctx3, 525, y - 50, 100, 100, GetImg('reload_close'), game.sounds.click);
    btn_reloadclose.call = 'ReloadClose';
    btn_reloadclose.draw();
    game.buttons.push(btn_reloadclose);

    var btn_reloadshop = GetNewButton(game.ctx3, 532, 0, 100, 100, dialogimages.btn_shop, game.sounds.click);
    btn_reloadshop.call = 'Shop';
    btn_reloadshop.draw();
    game.buttons.push(btn_reloadshop);

}

function ReloadClose() {

    HideAd();

    game.ctx3.clearRect(0, 0, game.width, game.height);

    DrawBackground();
    game.ctx1.clearRect(0, 0, game.width, game.height);
    game.ctxTemp.clearRect(0, 0, game.width, game.height);

    background.draw();
    sprites.draw();
    enemies.draw();
    player.draw();
    FreeButtons();
    game.screen = 'play';

    if (level.wind) {
        wind.draw();
        game.sounds.wind.play();
    }
    level.draw();
    rating.draw();

    txtlevel.text = game.level;
    txtlevel.draw();

    DrawCoins();

    if (level.night) {
        DrawFlares();
    }
    DrawBombs();

    FreeButtons();
    DestroyImg();

    left = GetNewButton(game.ctx3, 0, game.height - 250, 200, 200, gameimages.left, '', 0, 0, gameimages.left_on);
    game.buttons.push(left);
    right = GetNewButton(game.ctx3, 440, game.height - 250, 200, 200, gameimages.right, '', 0, 0, gameimages.right_on);
    game.buttons.push(right);
    pause = GetNewButton(game.ctx3, 520, 15, 150, 150, gameimages.pause, game.sounds.pause);
    pause.call = 'PauseGame';
    game.buttons.push(pause);

    deploy_bomb = GetNewButton(game.ctx3, 440, game.height - 375, 200, 125, gameimages.btn_bomb, '', 0, 0, gameimages.btn_bomb_on);
    deploy_bomb.call = 'DeployBomb';
    game.buttons.push(deploy_bomb);

    if (level.night) {
        deploy_flare = GetNewButton(game.ctx3, 0, game.height - 375, 200, 125, gameimages.btn_flare, '', 0, 0, gameimages.btn_flare_on);
        deploy_flare.call = 'DeployFlare';
        game.buttons.push(deploy_flare);
    }
    game.intro = true;
    game.reload = true;

    countdown.init(270, game.height_quarter, game.ctx3, gameimages.text_count);
}

function BuyBombs() {
    if (game.coin >= 1000) {
        game.coin -= 1000;
        game.bombs = game.bombcap;
        SetLocalStorage('MARS_COIN', game.coin);
        if (game.sound) {
            game.sounds.reload.play();
        }

        ReloadClose();

    } else {
        if (game.coin == 0) {
            Message('Insufficient Funds!', 'This item costs 1,000 coins. You have ' + game.coin + '.', ['Ok'], Ok);
        } else {
            Message('Insufficient Funds!', 'This item costs 1,000 coins. You only have ' + game.coin + '.', ['Ok'], Ok);
        }
    }
}

function BuyFlares() {
    if (game.coin >= 1000) {
        game.coin -= 1000;
        game.flares = game.flarecap;
        SetLocalStorage('MARS_COIN', game.coin);
        if (game.sound) {
            game.sounds.reload.play();
        }

        ReloadClose();

    } else {
        if (game.coin == 0) {
            Message('Insufficient Funds!', 'This item costs 1,000 coins. You have ' + game.coin + '.', ['Ok'], Ok);
        } else {
            Message('Insufficient Funds!', 'This item costs 1,000 coins. You only have ' + game.coin + '.', ['Ok'], Ok);
        }
    }
}

function DeployFlare() {
    if (game.flares > 0) {
        if (game.flares == 1) {
            game.message = true;
			reload.init(110, game.height_quarter - 7, game.ctx3, gameimages.text_reload, 0);
			sprites.sprite.push(reload);
        }
        game.flares -= 1;
        SetLocalStorage('MARS_FLARES', game.flares);
        DrawFlares2();

        var flare = GetNewFlare(player.x + 12 - player.panx, player.y + 25 - player.pany);
        sprites.sprite.push(flare);
        GetFlareSound();
    } else {
        game.play = !game.play;
        game.reload = true;
        ReloadNow(2);
    }
}

function DrawFlares2() {
    game.ctx3.clearRect(68, 205, 200, 50);
    game.ctx3.drawImage(gameimages.score_bg, 30, 0, 10, 50, 68, 205, (game.flares.toString().length * 22) - 10, 50);
    game.ctx3.drawImage(gameimages.score_bg, 120, 0, 30, 50, (game.flares.toString().length * 22) + 58, 205, 30, 50);
    txtflarecount.text = game.flares;
    txtflarecount.draw();
}

function DeployBomb() {
    if (game.bombs > 0) {
        if (game.bombs == 1) {
            game.message = true;
			reload.init(110, game.height_quarter - 7, game.ctx3, gameimages.text_reload, 0);
			sprites.sprite.push(reload);
        }
        game.bombs -= 1;
        SetLocalStorage('MARS_BOMBS', game.bombs);
        DrawBombs2();

        var bomb = GetNewBomb(player.x - 5 - player.panx, player.y + 25 - player.pany);
        sprites.sprite.push(bomb);
    } else {
        game.play = !game.play;
        game.reload = true;
        ReloadNow(1);
    }
}

function DrawBombs2() {
    game.ctx3.clearRect(68, 150, 200, 50);
    game.ctx3.drawImage(gameimages.score_bg, 30, 0, 10, 50, 68, 150, (game.bombs.toString().length * 22) - 10, 50);
    game.ctx3.drawImage(gameimages.score_bg, 120, 0, 30, 50, (game.bombs.toString().length * 22) + 58, 150, 30, 50);

    txtbombcount.text = game.bombs;
    txtbombcount.draw();
}

function SoundToggle(x, y, bg) {
    game.sound = !game.sound;
    game.ctx1.clearRect(x, y, 110, 122);
    game.ctx1.drawImage(dialogimages.btn_sound,
                        0, 0,
                        110, 122,
                        x, y,
                        110, 122);
    if (!game.sound) {
        game.ctx1.drawImage(dialogimages.btn_no_sound,
                            0, 0,
                            110, 100,
                            x, y,
                            110, 100);
    }
    SetLocalStorage('MARS_SOUND', game.sound);
}

function AddCoin() {
    game.coin += 100;
    SetLocalStorage('MARS_COIN', game.coin);
    DrawCoins();
}

function DrawCoins() {

    game.ctx3.clearRect(0, 95, 200, 50);
    game.ctx3.drawImage(gameimages.score_bg, 0, 0, 58, 50, 10, 95, 58, 50);
    game.ctx3.drawImage(gameimages.score_bg, 30, 0, 10, 50, 68, 95, (game.coin.toString().length * 22) - 10, 50);
    game.ctx3.drawImage(gameimages.score_bg, 120, 0, 30, 50, (game.coin.toString().length * 22) + 58, 95, 30, 50);

    game.ctx3.drawImage(gameimages.coins, 0, 0, 60, 60, 20, 100, 40, 40);
    txtcoin.y = 106;
    txtcoin.text = game.coin;
    txtcoin.draw();
}

function NewGame() {
    game.level = GetLocalStorage('MARS_LEVEL', game.level);
    if (game.level == game.limit) game.level -= 1;
    Loading();
}

function NextLevel() {
	player.landed = false;
    player.landedsplash = false;
    landcount = 0;
    newlevel = true;
	player.crash = false;
    game.attempts = 0;
    FreeButtons();
	redolevel = false;
	
    if (game.level == game.limit) { //end
        LoadingMenu();
        if (!game.ads || game.bombcap > 3 || game.flarecap > 5 || game.fuel || game.shields || game.lander) {
            Message('Congratulations!', 'You have just completed the first 50 levels of Mars Lander: Rescue! Be on the lookout for more epic adventures coming soon.', ['Ok'], Ok);
        } else {
            Message('Congratulations!', 'You have just completed the first 50 levels of Mars Lander: Rescue! If you would like to see future epic adventures, please consider supporting this game by purchasing an upgrade.', ['Ok'], Ok);
        }
    } else {
        game.level += 1;
        Loading();
    }
}
var redolevel = false;
function RedoLevel() {
    player.landed = false;
    player.landedsplash = false;
	landcount = 0;
	player.crash = false;
    game.attempts += 1;
    HideAd();
    FreeButtons();
	redolevel = true;
	
    if (game.ads && game.attempts % game.maxAttempts == 0) {
        FullPageAd();
    } else {
        LoadGame();
    }
}

function LoadingMenu() {
    Load();

    DestroyImg();

    LoadImg(MenuImages, function () {
        Menu();
    });
}

function LoadingAd() {
    Load();
    
    LoadImg(AdImages, function () {
        ShowFullPageAd();
    });
}

function LoadingReview() {
    game.ctx3.drawImage(bg_loading, 0, 0);

    LoadImg(ReviewImages, function () {
        ReviewShow();
    });
}

function LoadingOnBoard() {
    LoadImg(OnBoardImages, function () {
        OnBoardShow();
    });
}

function LoadingReload() {
	LoadImg(ReloadImages, function () {
		ReloadShow();
	});
}

function LoadingShop() {
    game.ctx3.drawImage(bg_loading, 0, 0);

    LoadImg(ShopImages, function () {
	    ShowShop();
    });
}
var backgroundimage = {
	
};
var levelimages = {
	
};

function LoadGame() {
    Load();

	if (redolevel){
		game.ctx1.clearRect(0, 0, game.width, game.height);
		InitGame();
	}else{
		LoadImages2(GetObject(game.level).images, levelimages, function (images) {
			levelimages = images;
			game.ctx1.clearRect(0, 0, game.width, game.height);
			InitGame();
		});
	}
}

function Loading() {
    if (game.ads && game.onboard) {
        FullPageAd();
    } else {
        LoadGame();
    }
}

var count_bomb = 0;
function GetBombSound() {
    if (game.sound) {
        count_bomb++;
        if (count_bomb > 3) count_bomb = 1;
        if (count_bomb == 1) {
            game.sounds.bomb1.snd.volume = 0.35;
            game.sounds.bomb1.play();
        }
        if (count_bomb == 2) {
            game.sounds.bomb2.snd.volume = 0.35;
            game.sounds.bomb2.play();
        }
        if (count_bomb == 3) {
            game.sounds.bomb3.snd.volume = 0.35;
            game.sounds.bomb3.play();
        }
    }
}

var count_flare = 0;
function GetFlareSound() {
    if (game.sound) {
        count_flare++;
        if (count_flare > 2) count_flare = 1;
        if (count_flare == 1) game.sounds.flare1.play();
        if (count_flare == 2) game.sounds.flare2.play();
    }
}

var count_swoosh = 0;
function GetSwooshSound() {
    if (game.sound) {
        count_swoosh++;
        if (count_swoosh > 3) count_swoosh = 1;
        if (count_swoosh == 1) game.sounds.swoosh1.play();
        if (count_swoosh == 2) game.sounds.swoosh2.play();
        //if (count_swoosh == 3) game.sounds.swoosh3.play();
    }
}

var count_collect = 0;
function GetCollectSound() {
    if (game.sound) {
        count_collect++;
        if (count_collect > 2) count_collect = 1;
        if (count_collect == 1) game.sounds.collect.play();
        if (count_collect == 2) game.sounds.collect2.play();
    }
}

function Load() {
    //game.buttons = [];
    //level.ary = [];
    //sprites.sprite = [];
    player.landed = false;
    player.landedsplash = false;
	landcount = 0;
    game.menu = false;
    game.bombs = game.bombcap;
    game.flares = game.flarecap;

    //HideAd();
    
    game.ctx0.clearRect(0, 0, game.width, game.height);
    game.ctx1.clearRect(0, 0, game.width, game.height);
    game.ctx3.clearRect(0, 0, game.width, game.height);
    game.ctxTemp.clearRect(0, 0, game.width, game.height);

    game.ctx1.drawImage(bg_loading, 0, 0);
}

function DrawBackground (){
    if (levelimages.background.src.indexOf('blue') != -1) {
        game.ctx0.fillStyle = '#00CCCC';
        game.ctx0.fillRect(0, 0, game.width, game.height);
        game.ctx0.drawImage(levelimages.background, 0, 0);
    } else if (levelimages.background.src.indexOf('green') != -1) {
        game.ctx0.fillStyle = '#C5F4AE';
        game.ctx0.fillRect(0, 0, game.width, game.height);
        game.ctx0.drawImage(levelimages.background, 0, 0);
    } else if (levelimages.background.src.indexOf('brown') != -1) {
        game.ctx0.fillStyle = '#EDB35B';
        game.ctx0.fillRect(0, 0, game.width, game.height);
        game.ctx0.drawImage(levelimages.background, 0, 0);
    } else { //if (levelimages.background.src.indexOf('night') != -1 || levelimages.background.src.indexOf('white') != -1) {
        DrawTile(game.ctx0, levelimages.background);
    }
}

var left, right, pause, deploy_flare, deploy_bomb;

function InitGame() {

    game.screen = 'play';
    game.play = false;
    game.intro = true;
    game.menu = false;
    game.paused = false;

    game.counter = 8;
    game.counter2 = 0;
    game.delay = Date.now();

    enemies.reset();
    sprites.reset();
    rating.reset();
    player.reset();
    
    level.init();

	DrawBackground();
    
    left = GetNewButton(game.ctx3, 0, game.height - 250, 200, 200, gameimages.left, '', 0, 0, gameimages.left_on);
    game.buttons.push(left);
    right = GetNewButton(game.ctx3, 440, game.height - 250, 200, 200, gameimages.right, '', 0, 0, gameimages.right_on);
    game.buttons.push(right);
    pause = GetNewButton(game.ctx3, 520, 15, 150, 150, gameimages.pause, game.sounds.pause);
    pause.call = 'PauseGame';
    game.buttons.push(pause);

    player.panx = player.x - (pad.x + (pad.width / 2) - 20);
    player.pany = player.y + 60 - pad.y;

    if (Math.abs(player.panx) >= Math.abs(player.pany)) {
        player.panxstep = 10;
        player.panystep = Math.abs(player.pany / (player.panx / 10));
    } else {
        player.panystep = 10;
        player.panxstep = Math.abs(player.panx / (player.pany / 10));
    }

    player.y = player.y + player.pany;

    if (player.panx < 0) game.pandir = 1;
    else game.pandir = -1;
    if (player.pany > 0) game.panydir = -1;
    else game.panydir = 1;

    fade.draw();

    if (level.wind) {
        game.sounds.wind.play();
    }

    //HideAd();
}
var fullpage = false;
var newlevel = true;
var adcount = 0;
function FullPageAd() {
    HideAd();
    game.ctx3.drawImage(bg_loading, 0, 0);
    try {
        if (adcount >= 30) {
            LoadingAd();
        } else {
            admob.interstitial.prepare();
        }
    } catch (e) {
        LoadingAd();
    }
}
//function FullPageAd() {
//	HideAd();

//    if (adcount >= 20) {
//        LoadingAd();
//        try {
//            admob.banner.prepare();
//        } catch (e) { }
//    } else if (game.interstitial.loaded) {
//        game.ctx3.drawImage(bg_loading, 0, 0);
//        if (newlevel) {
//            adcount++;
//            newlevel = false;
//        }
//        admob.interstitial.show();
//    } else {
//		fullpage = true;
//        LoadingAd();
//        try {
//			admob.interstitial.prepare();
//        } catch (e) { }
//    }
//}

var blnFullPageAd = false, blnBannerAd = false;
function ShowFullPageAd() {
    game.ctx3.drawImage(GetImg('banner_interstitial'), 0, 0);
    if (game.height > 960) game.ctx3.drawImage(GetImg('ground'), 0, 900);
    var close = GetNewButton(game.ctx3, 0, 0, 100, 100, GetImg('btn_settings_close'), '');
    close.call = 'CloseFullPageAd';
    close.draw();
	game.buttons.push(close);
    var buy = GetNewButton(game.ctx3, 142, 560, 357, 123, '', '');
    buy.call = 'BuyNoAd';
    buy.active = true;
    game.buttons.push(buy);
    txtad.text = '(' + game.productPrice_noad + ')';
    var width = txtad.overalwidth();
    txtad.x = (320 - width / 2);
	txtad.y = 675;
    txtad.draw();
}

function CloseFullPageAd() {
    FreeButtons();
    DestroyImg();
    LoadGame();
}

function ShowAd() {
    //if (game.banner.loaded) {
    //    admob.banner.show();
    //} else {
    //    game.ctx1.drawImage(dialogimages.banner_ad, 0, game.height - 80);
    //    var buy = GetNewButton(game.ctx1, 0, game.height - 80, 640, 80, '', '');
    //    buy.call = 'BuyNoAdBanner';
    //    buy.active = true;
	//	game.buttons.push(buy);
    //    try {
    //        admob.banner.prepare();
    //    } catch (e) { }
    //}
}
function HideAd() {
    //if (game.ads) {
    //    try {
    //        admob.banner.hide();
    //    } catch (e) { }
    //    //game.ctx1.clearRect(0, game.height - 80, 640, 80);
    //}
}

function Buy(index) {
    var id = '';
    if (index == 1) {
        id = game.productIds.bombcap;
    } else if (index == 2) {
        id = game.productIds.flarecap;
    } else if (index == 3 && !game.shields) {
        id = game.productIds.shields;
    } else if (index == 4 && !game.fuel) {
        id = game.productIds.fuel;
    } else if (index == 5 && game.type != 1) {
        blnReloadLevel = true;
        SetLander();
        ShopUpdate();
        return;
    } else if (index == 6) {
        if (!game.lander) {
            id = game.productIds.lander;
        } else if (game.type != 2){
            blnReloadLevel = true;
            SetApollo();
            ShopUpdate();
            return;
        }
    } else if (index == 7 && !game.comboa) {
        id = game.productIds.comboa;
    } else if (index == 8 && !game.combob) {
        id = game.productIds.combob;
    } else if (index == 9) {
        id = game.productIds.coin1;
    } else if (index == 10) {
        id = game.productIds.coin2;
    } else if (index == 11 && game.ads) {
        id = game.productIds.noad;
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////////////***remove
    //if (id != '') BuyReturn(id);
    /////////////////////////////////////////////////////////////////////////////////////////////////***remove
    var canpur = true;
    if (id == game.productIds.bombcap && !blnvalid_bombcap) {
        canpur = false;
    } else if (id == game.productIds.flarecap && !blnvalid_flarecap) {
        canpur = false;
    } else if (id == game.productIds.noad && !blnvalid_noad) {
        canpur = false;
    } else if (id == game.productIds.fuel && !blnvalid_fuel) {
        canpur = false;
    } else if (id == game.productIds.shields && !blnvalid_shields) {
        canpur = false;
    } else if (id == game.productIds.comboa && !blnvalid_comboa) {
        canpur = false;
    } else if (id == game.productIds.combob && !blnvalid_combob) {
        canpur = false;
    } else if (id == game.productIds.coin1 && !blnvalid_coin1) {
        canpur = false;
    } else if (id == game.productIds.coin2 && !blnvalid_coin2) {
        canpur = false;
    } else if (id == game.productIds.lander && !blnvalid_lander) {
        canpur = false;
    }
    if (!canpur) {
        Message('Cannot Purchase', "You cannot make purchases at this time. Try again in a moment. Please check that you are connected to the internet and make sure to enable In-App-Purchases on your phone.", ['Ok'], Ok);

    } else {
        if (game.canPurchase && id != '') {
            store.order(id);
        } else if (!game.canPurchase) {
            Message('Cannot Purchase', "You cannot make purchases at this time. Try again in a moment. Please check that you are connected to the internet and make sure to enable In-App-Purchases on your phone.", ['Ok'], Ok);
        }
    }
}

function BuyNoAd() {
    if (game.canPurchase) {
        blnFullPageAd = true;
        store.order(game.productIds.noad);
    } else {
        Message('Cannot Purchase', "You cannot make purchases at this time. Try again in a moment. Please check that you are connected to the internet and make sure to enable In-App-Purchases on your phone.", ['Ok'], Ok);
    }
}

function BuyNoAdBanner() {
    if (game.canPurchase) {
        blnBannerAd = true;
        store.order(game.productIds.noad);
    } else {
        Message('Cannot Purchase', "You cannot make purchases at this time. Try again in a moment. Please check that you are connected to the internet and make sure to enable In-App-Purchases on your phone.", ['Ok'], Ok);
    }
}
var coinup_shop = {
    x: 0,
    y: 0,
    count: 0,
    index: 0
};

var blnReloadLevel = false;
function BuyReturn(id) {
    if (id == game.productIds.coin1) {
        game.coin += 10000;
        if (game.sound) {
            game.sounds.collect.play();
        }
        coinup_shop.x = 480;
        coinup_shop.y = game.height - 600;
        SetLocalStorage('MARS_COIN', game.coin);
    } else if (id == game.productIds.coin2) {
        game.coin += 100000;
        if (game.sound) {
            game.sounds.collect.play();
        }
        coinup_shop.x = 480;
        coinup_shop.y = game.height - 492;
        SetLocalStorage('MARS_COIN', game.coin);
    } else if (id == game.productIds.noad) {
        game.ads = false;
        game.adHeight = 0;
        SetLocalStorage('MARS_ADS', false);
    } else if (id == game.productIds.fuel) {
        game.ads = false;
        game.adHeight = 0;
        SetLocalStorage('MARS_ADS', false);
        game.fuel = true;
        SetFuel();
        rating = new DoubleRating();
        blnReloadLevel = true;
        SetLocalStorage('MARS_FUEL', true);
        if (game.shields) {
            game.comboa = true;
            SetLocalStorage('MARS_COMBOA', true);
        }
    } else if (id == game.productIds.shields) {
        game.ads = false;
        game.adHeight = 0;
        SetLocalStorage('MARS_ADS', false);
        game.shields = true;
        SetShields();
        blnReloadLevel = true;
        SetLocalStorage('MARS_SHIELDS', true);
        if (game.fuel) {
            game.comboa = true;
            SetLocalStorage('MARS_COMBOA', true);
        }
    } else if (id == game.productIds.lander) {
        game.lander = true;
        SetApollo();
        blnReloadLevel = true;
        SetLocalStorage('MARS_LANDER', true);
    } else if (id == game.productIds.comboa) {
        game.ads = false;
        game.adHeight = 0;
        SetLocalStorage('MARS_ADS', false);
        game.fuel = true;
        SetFuel();
        rating = new DoubleRating();
        SetLocalStorage('MARS_FUEL', true);
        game.shields = true;
        SetShields();
        SetLocalStorage('MARS_SHIELDS', true);
        blnReloadLevel = true;
        game.comboa = true;
        SetLocalStorage('MARS_COMBOA', true);
    } else if (id == game.productIds.bombcap) {
        game.ads = false;
        game.adHeight = 0;
        SetLocalStorage('MARS_ADS', false);
        game.bombcap = 10;
        SetLocalStorage('MARS_BOMBCAP', game.bombcap);
        if (game.flarecap == 20) {
            game.combob = true;
            SetLocalStorage('MARS_COMBOB', true);
        }
        blnReloadLevel = true;
    } else if (id == game.productIds.flarecap) {
        game.ads = false;
        game.adHeight = 0;
        SetLocalStorage('MARS_ADS', false);
        game.flarecap = 20;
        SetLocalStorage('MARS_FLARECAP', game.flarecap);
        if (game.bombcap == 10) {
            game.combob = true;
            SetLocalStorage('MARS_COMBOB', true);
        }
        blnReloadLevel = true;
    } else if (id == game.productIds.combob) {
        game.ads = false;
        game.adHeight = 0;
        SetLocalStorage('MARS_ADS', false);
        game.bombcap = 10;
        SetLocalStorage('MARS_BOMBCAP', game.bombcap);
        game.flarecap = 20;
        SetLocalStorage('MARS_FLARECAP', game.flarecap);
        game.combob = true;
        SetLocalStorage('MARS_COMBOB', true);
        blnReloadLevel = true;
    }

    if (blnFullPageAd) {
        blnFullPageAd = false;
        CloseFullPageAd();
        return;
    }

    if (blnBannerAd) {
        blnBannerAd = false;
        game.ctx1.clearRect(0, game.height - 80, 640, 80);
        try {
            buy.active = false;
        } catch (e) { }
        return;
    }
    
    if (game.shopping || game.shop) {
        ShopUpdate();
    }
}

function SetShields() {
    game.rates.hit = {
        meteor: 5,
        tornado: 5,
        bomb: 20
    };
    var obj = { shields: 'images/2xshields.png' };
    LoadImages2(obj, gameimages, function (images) {
        gameimages.shields = images.shields;
    });
}

function SetFuel() {
    game.rates.fuel = {
        single: 0.05,
        double: 0.075
    };
    game.rates.hit = {
        meteor: 5,
        tornado: 5,
        bomb: 20
    };
}

function SetLander(){
    game.type = 1;
    SetLocalStorage('MARS_TYPE', 1);

    var obj = {
        ship: 'images/ship.png?v3',
        red_light: 'images/red_light.png',
        lthrust: 'images/thrust_left2.png',
        rthrust: 'images/thrust_right2.png'
    };
    LoadImages2(obj, gameimages, function (images) {
        gameimages.ship = images.ship;
        gameimages.red_light = images.red_light;
        gameimages.lthrust = images.lthrust;
        gameimages.rthrust = images.rthrust;
    });
}

function SetApollo(){
    game.type = 2;
    SetLocalStorage('MARS_TYPE', 2);
    var obj = {
        ship: 'images/lander.png?v5',
        red_light: 'images/red_light_lander.png',
        lthrust: 'images/lander_thrust_left.png',
        rthrust: 'images/lander_thrust_right.png'
    };
    LoadImages2(obj, gameimages, function (images) {
        gameimages.ship = images.ship;
        gameimages.red_light = images.red_light;
        gameimages.lthrust = images.lthrust;
        gameimages.rthrust = images.rthrust;
    });
}

function Restore() {
    try {
        store.refresh();
    } catch (e) { }
}

function Skip() {
    if (game.score[game.level] == undefined) {
        game.score.push(0.0);
        SetLocalStorage('MARS_LEVEL', game.level + 1);
        SetLocalStorage('MARS_SCORE', game.score);
    }

    NextLevel();
}

function ShareGame() {
    try {

        var object = {
            message: game.share.message,
            subject: game.share.subject,
            files: [game.share.image],
            url: game.share.url
        }

        var onSuccess = function (result) { };
        var onError = function (msg) { };

        window.plugins.socialsharing.shareWithOptions(object, onSuccess, onError);

    } catch (e) { console.log(e); }
}

var gameButtons = [];
function SaveButtons() {
    gameButtons = game.buttons;
    game.buttons = [];
}
function RestoreButtons() {
    game.buttons = gameButtons;
    gameButtons = [];
}
var gameButtons2 = [];
function SaveButtons2() {
    gameButtons2 = game.buttons;
    game.buttons = [];
}
function RestoreButtons2() {
    game.buttons = gameButtons2;
    gameButtons2 = [];
}
var gameSprites = [];
function SaveSprites() {
    gameSprites = sprites.sprite;
    sprites.sprite = [];
}
function RestoreSprites() {
    sprites.sprite = gameSprites;
    gameSprites = [];
}
/***********************************************************************************************/
if (window.cordova) document.addEventListener("deviceready", Initialize);
else window.onload = Initialize;

function Initialize() {

    try {
        if (StatusBar) StatusBar.hide();
    } catch (e) { }

    game.init();

    var img = new Image(),
        bg = new Image(),
        bg_night = new Image(),
        text_loading = new Image(),
        now = Date.now(),
        timeout = 2200,
        delta;

    img.src = 'images/smashola.png?v20';
    img.onload = function () {
        bg.src = 'images/home_splash2.png?v1';
        bg.onload = function () {

            game.ctx0.fillStyle = '#0099FF';
            game.ctx0.fillRect(0, 0, game.width, game.height);
            game.ctx0.drawImage(bg, 0, game.height - 960);
            game.ctx1.drawImage(img, 90, game.height_half - 204);

            bg_night.src = 'images/bg_space.png?v2';
            bg_night.onload = function () {

                text_loading.src = 'images/text_loading.png';
                text_loading.onload = function () {
                    LoadSounds(InitSounds, function () {
                        LoadImages2(DialogImages, dialogimages, function (img) {
                            dialogimages = img;

                            LoadImages2(GameImages, gameimages, function (img) {
                                gameimages = img;
                                
                                LoadImg(HomeImages, function () {

                                    InitializeStore();
                                    LoadAdMob();

                                    delta = Date.now() - now;
                                    if (delta >= timeout) timeout = 0;
                                    else timeout = timeout - delta;

                                    if (navigator.splashscreen) navigator.splashscreen.hide();
                                    setTimeout(function () {
										game.reinit();
										
										game.ctx0.fillStyle = '#0099FF';
										game.ctx0.fillRect(0, 0, game.width, game.height);
										game.ctx0.drawImage(bg, 0, game.height - 960);
										
										bg_loading = CreateOffScreenCanvas(game.width, game.height);
										var ctx = bg_loading.getContext('2d');
										DrawTile(ctx, bg_night);
										ctx.drawImage(text_loading, 195, game.height_half - 23);
										
										img = null;
										bg = null;
									
                                        game.load();
                                        game.initEvents();
                                    }, timeout);

                                });
                            });
                        });
                    });
                }

            }

        }
    }

}

var blnvalid_noad = false;
var blnvalid_fuel = false;
var blnvalid_shields = false;
var blnvalid_comboa = false;
var blnvalid_combob = false;
var blnvalid_lander = false;
var blnvalid_bombcap = false;
var blnvalid_flarecap = false;
var blnvalid_coin1 = false;
var blnvalid_coin2 = false;

function InitializeStore() {
    try {

        store.register({
            id: game.productIds.noad,
            alias: game.productIds.noad,
            type: store.NON_CONSUMABLE
        });

        store.when(game.productIds.noad).approved(function (order) {
            order.finish();
            BuyReturn(game.productIds.noad);
        });

        store.when(game.productIds.noad).loaded(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_noad = true;
            }
            if (product.price) {
                game.productPrice_noad = product.price;
                SetLocalStorage('MARS_PRICE_ADS', game.productPrice_noad);
            }
        });
        store.when(game.productIds.noad).updated(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_noad = true;
            }
            if (product.price) {
                game.productPrice_noad = product.price;
                SetLocalStorage('MARS_PRICE_ADS', game.productPrice_noad);
            }
            if (product.owned) {
                BuyReturn(game.productIds.noad);
            }
        });

        /////////////////

        store.register({
            id: game.productIds.shields,
            alias: game.productIds.shields,
            type: store.NON_CONSUMABLE
        });

        store.when(game.productIds.shields).approved(function (order) {
            order.finish();
            BuyReturn(game.productIds.shields);
        });

        store.when(game.productIds.shields).loaded(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_shields = true;
            }
            if (product.price) {
                game.productPrice_shields = product.price;
                SetLocalStorage('MARS_PRICE_SHIELDS', game.productPrice_shields);
            }
        });
        store.when(game.productIds.shields).updated(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_shields = true;
            }
            if (product.price) {
                game.productPrice_shields = product.price;
                SetLocalStorage('MARS_PRICE_SHIELDS', game.productPrice_shields);
            }
            if (product.owned) {
                BuyReturn(game.productIds.shields);
            }
        });

        /////////////////

        store.register({
            id: game.productIds.fuel,
            alias: game.productIds.fuel,
            type: store.NON_CONSUMABLE
        });

        store.when(game.productIds.fuel).approved(function (order) {
            order.finish();
            BuyReturn(game.productIds.fuel);
        });

        store.when(game.productIds.fuel).loaded(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_fuel = true;
            }
            if (product.price) {
                game.productPrice_fuel = product.price;
                SetLocalStorage('MARS_PRICE_FUEL', game.productPrice_fuel);
            }
        });

        store.when(game.productIds.fuel).updated(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_fuel = true;
            }
            if (product.price) {
                game.productPrice_fuel = product.price;
                SetLocalStorage('MARS_PRICE_FUEL', game.productPrice_fuel);
            }
            if (product.owned) {
                BuyReturn(game.productIds.fuel);
            }
        });

        /////////////////

        store.register({
            id: game.productIds.lander,
            alias: game.productIds.lander,
            type: store.NON_CONSUMABLE
        });

        store.when(game.productIds.lander).approved(function (order) {
            order.finish();
            BuyReturn(game.productIds.lander);
        });

        store.when(game.productIds.lander).loaded(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_lander = true;
            }
            if (product.price) {
                game.productPrice_lander = product.price;
                SetLocalStorage('MARS_PRICE_LANDER', game.productPrice_lander);
            }
        });

        store.when(game.productIds.lander).updated(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_lander = true;
            }
            if (product.price) {
                game.productPrice_lander = product.price;
                SetLocalStorage('MARS_PRICE_LANDER', game.productPrice_lander);
            }
            if (product.owned) {
                BuyReturn(game.productIds.lander);
            }
        });

        /////////////////

        store.register({
            id: game.productIds.comboa,
            alias: game.productIds.comboa,
            type: store.NON_CONSUMABLE
        });

        store.when(game.productIds.comboa).approved(function (order) {
            order.finish();
            BuyReturn(game.productIds.comboa);
        });

        store.when(game.productIds.comboa).loaded(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_comboa = true;
            }
            if (product.price) {
                game.productPrice_comboa = product.price;
                SetLocalStorage('MARS_PRICE_COMBOA', game.productPrice_comboa);
            }
        });

        store.when(game.productIds.comboa).updated(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_comboa = true;
            }
            if (product.price) {
                game.productPrice_comboa = product.price;
                SetLocalStorage('MARS_PRICE_COMBOA', game.productPrice_comboa);
            }
            if (product.owned) {
                BuyReturn(game.productIds.comboa);
            }
        });

        /////////////////

        store.register({
            id: game.productIds.combob,
            alias: game.productIds.combob,
            type: store.NON_CONSUMABLE
        });

        store.when(game.productIds.combob).approved(function (order) {
            order.finish();
            BuyReturn(game.productIds.combob);
        });

        store.when(game.productIds.combob).loaded(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_combob = true;
            }
            if (product.price) {
                game.productPrice_combob = product.price;
                SetLocalStorage('MARS_PRICE_COMBOB', game.productPrice_combob);
            }

        });
        store.when(game.productIds.combob).updated(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_combob = true;
            }
            if (product.price) {
                game.productPrice_combob = product.price;
                SetLocalStorage('MARS_PRICE_COMBOB', game.productPrice_combob);
            }
            if (product.owned) {
                BuyReturn(game.productIds.combob);
            }
        });

        /////////////////

        store.register({
            id: game.productIds.bombcap,
            alias: game.productIds.bombcap,
            type: store.NON_CONSUMABLE
        });

        store.when(game.productIds.bombcap).approved(function (order) {
            order.finish();
            BuyReturn(game.productIds.bombcap);
        });

        store.when(game.productIds.bombcap).loaded(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_bombcap = true;
            }
            if (product.price) {
                game.productPrice_bombcap = product.price;
                SetLocalStorage('MARS_PRICE_BOMBCAP', game.productPrice_bombcap);
            }
        });

        store.when(game.productIds.bombcap).updated(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_bombcap = true;
            }
            if (product.price) {
                game.productPrice_bombcap = product.price;
                SetLocalStorage('MARS_PRICE_BOMBCAP', game.productPrice_bombcap);
            }
            if (product.owned) {
                BuyReturn(game.productIds.bombcap);
            }
        });

        /////////////////

        store.register({
            id: game.productIds.flarecap,
            alias: game.productIds.flarecap,
            type: store.NON_CONSUMABLE
        });

        store.when(game.productIds.flarecap).approved(function (order) {
            order.finish();
            BuyReturn(game.productIds.flarecap);
        });

        store.when(game.productIds.flarecap).loaded(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_flarecap = true;
            }
            if (product.price) {
                game.productPrice_flarecap = product.price;
                SetLocalStorage('MARS_PRICE_FLARECAP', game.productPrice_flarecap);
            }
        });

        store.when(game.productIds.flarecap).updated(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_flarecap = true;
            }
            if (product.price) {
                game.productPrice_flarecap = product.price;
                SetLocalStorage('MARS_PRICE_FLARECAP', game.productPrice_flarecap);
            }
            if (product.owned) {
                BuyReturn(game.productIds.flarecap);
            }
        });

        /////////////////

        store.register({
            id: game.productIds.coin1,
            alias: game.productIds.coin1,
            type: store.CONSUMABLE
        });

        store.when(game.productIds.coin1).approved(function (order) {
            order.finish();
            BuyReturn(game.productIds.coin1);
        });

        store.when(game.productIds.coin1).loaded(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_coin1 = true;
            }
            if (product.price) {
                game.productPrice_coin1 = product.price;
                SetLocalStorage('MARS_PRICE_COIN1', game.productPrice_coin1);
            }
        });
        store.when(game.productIds.coin1).updated(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_coin1 = true;
            }
            if (product.price) {
                game.productPrice_coin1 = product.price;
                SetLocalStorage('MARS_PRICE_COIN1', game.productPrice_coin1);
            }
        });

        /////////////////

        store.register({
            id: game.productIds.coin2,
            alias: game.productIds.coin2,
            type: store.CONSUMABLE
        });

        store.when(game.productIds.coin2).approved(function (order) {
            order.finish();
            BuyReturn(game.productIds.coin2);
        });

        store.when(game.productIds.coin2).loaded(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_coin2 = true;
            }
            if (product.price) {
                game.productPrice_coin2 = product.price;
                SetLocalStorage('MARS_PRICE_COIN2', game.productPrice_coin2);
            }
        });
        store.when(game.productIds.coin2).updated(function (product) {
            if (!product) return;
            if (product.valid) {
                blnvalid_coin2 = true;
            }
            if (product.price) {
                game.productPrice_coin2 = product.price;
                SetLocalStorage('MARS_PRICE_COIN2', game.productPrice_coin2);
            }
        });

        /////////////////

        store.ready(function () { });
        store.error(function () { game.canPurchase = false; });
        store.refresh();

    } catch (e) {

        console.log('Cannot make purchases');
        game.canPurchase = false;
    }
}
	
function LoadAdMob() {
    try {

        game.ads = GetLocalStorage('MARS_ADS', game.ads);
        if (!game.ads) game.adHeight = 0;

        if (game.ads && admob) {	
		
            //admob.banner.config({
            //    id: game.adService.android.banner,
            //    isTesting: true,
            //    bannerAtTop: false,
            //    overlap: true,
            //    autoShow: false
            //});
            //admob.banner.prepare();
            
            admob.interstitial.config({
                id: game.adService.android.interstitial,
                isTesting: false,
                autoShow: false
            });

            //document.addEventListener('admob.banner.events.LOAD_FAIL', function (event) {
            //    game.banner.loaded = false;
            //    game.adHeight = 80;
            //});
            //document.addEventListener('admob.banner.events.LOAD', function (event) {
            //    game.banner.loaded = true;
            
            //    if (window.innerWidth > 450) {
            //        game.adHeight = Math.round(90 * game.scale);
            //    } else {
            //        game.adHeight = Math.round(50 * game.scale);
            //    }
            
            //});
            //document.addEventListener('admob.banner.events.CLOSE', function (event) {
            //    game.banner.loaded = false;
            //    admob.banner.prepare();
            //});
            
            document.addEventListener('admob.interstitial.events.LOAD_FAIL', function (event) {
                LoadingAd();
            });
            document.addEventListener('admob.interstitial.events.LOAD', function (event) {
                admob.interstitial.show();
                if (newlevel) {
                    adcount++;
                    newlevel = false;
                }
            });
            document.addEventListener('admob.interstitial.events.CLOSE', function (event) {
                LoadGame();
            });

        }


    } catch (e) {
        console.log('Ads not supported');
        game.banner.loaded = false;
        game.interstitial.loaded = false;
        //game.adHeight = 80;
    }
}

/***********************************************************************************************/
var ActiveImages = [];
var ImagePool = [];

function GetNewImage() {
    var b = null;
    if (ImagePool.length > 0) {
        b = ImagePool.pop();
    } else {
        b = document.createElement('img');
    }
    ActiveImages.push(b);
    return b;
}
function LoadImg(sources, callback) {
    var numLoaded = 0,
        numImages = 0;
    for (var src in sources) {
        numImages++;
    }
    if (numImages == 0) callback();
    for (var src in sources) {
        
        var img = GetNewImage();
        img.onload = function () {
            if (img.id == 'empty') return;
            if (++numLoaded >= numImages) {
                callback();
                return;
            }
        };
        img.src = sources[src];
        img.id = src;
    }
}
function DestroyImg() {
    for (var i = ActiveImages.length - 1; i >= 0; i--) {
        ActiveImages[i].src = 'images/1x1.png';
        ActiveImages[i].id = 'empty';
        ImagePool.push(ActiveImages[i]);
        ActiveImages.splice(i, 1);
    }
    ActiveImages.length = 0;
}
function GetImg(id) {
    var pos = ActiveImages.map(function (x) { return x.id; }).indexOf(id);
    return ActiveImages[pos];
}

/***********************************************************************************************/
function LoadImages2(names, global, callback) {
    var numImages = 0;
    for (var src in names) {
        numImages++;
    }
    var n, name,
        result = {},
        count = numImages,
        onload = function () {
            if (--count == 0) callback(result);
        };

    for (var src in names) {
        name = src;
        //if (global[name] == undefined) {
            result[name] = document.createElement('img');
        //} else {
        //    result[name] = global[name];
		//	result[name].removeEventListener('load', onload);
        //}
        result[name].addEventListener('load', onload);
        result[name].src = names[src];

    }
}

/***********************************************************************************************/
function LoadSounds(sounds, callback) {
    var numLoaded = 0,
        numSounds = 0;

    for (var src in sounds) {
        numSounds++;
    }
    if (numSounds == 0) callback();
    for (var src in sounds) {
        game.sounds[src] = new Sound(sounds[src]);
    }
    setTimeout(function () { CheckReadyState(callback); }, 100);
}

function CheckReadyState(callback) {
    for (var src in game.sounds) {
        if (!game.sounds[src].loaded) {
            setTimeout(function () { CheckReadyState(callback); }, 100);
            return false;
        }
    }
    callback();
}
function DestroySounds(sounds) {
    for (var src in sounds) {
        if (game.sounds[src] != undefined) {
            try {
                game.sounds[src].dispose();
                game.sounds[src] = null;
            } catch (e) {
                game.sounds[src] = null;
            }
            delete game.sounds[src];
        }
    }
}
/***********************************************************************************************/
function Timer(callback, delay) {
    var timerId, start, remaining = delay;

    this.pause = function () {
        window.clearTimeout(timerId);
        remaining -= new Date() - start;
    };

    this.resume = function () {
        start = new Date();
        window.clearTimeout(timerId);
        timerId = window.setTimeout(callback, remaining);
    };

    this.resume();
}
/***********************************************************************************************/
function CreateOffScreenCanvas(width, height) {
    var canvas = document.createElement('canvas');
    canvas.width = width;
    canvas.height = height;
    return canvas;
}

function DrawTile(layer, img) {
    for (var height = 0; height <= game.height; height += img.height) {
        layer.drawImage(img, 0, height);
    }
}
/***********************************************************************************************/
function Frame() {
    var now = Date.now(),
        frame = now - game.then;
    if (frame < game.smallestFrame) return 0;
    if (frame > game.longestFrame) frame = game.typicalFrame;
    game.then = now;
    return frame;
}
/***********************************************************************************************/
var blurtemp = CreateOffScreenCanvas(400, 600),
    ctxblurtemp = blurtemp.getContext('2d'),
    blurtemp2 = CreateOffScreenCanvas(250, 375),
    ctxblurtemp2 = blurtemp2.getContext('2d');

function Blur(canvas, ctx, depth, width, height) {

    var W = 400,
        H = 600,
        alpha = 0.5;

    ctxblurtemp.drawImage(canvas, 0, 0, width, height, 0, 0, W, H);

    ctx.clearRect(0, 0, game.width, game.height);

    for (var i = 1; i <= depth; i++) {
        ctx.globalAlpha = alpha;
        alpha -= 0.1;
        alpha = alpha.toFixed(2);
        for (var y = -1; y <= 1; y++) {
            for (var x = -1; x <= 1; x++) {
                ctx.drawImage(blurtemp, x, y, W, H, 0, 0, game.width, game.height);
            }
        }
    }

    W = 250;
    H = 375;
    alpha = 0.125;

    ctxblurtemp2.drawImage(canvas, 0, 0, width, height, 0, 0, W, H);

    for (var i = 1; i <= depth; i += 1) {
        ctx.globalAlpha = alpha;
        alpha -= 0.05;
        alpha = alpha.toFixed(2);
        for (var y = -1; y <= 1; y++) {
            for (var x = -1; x <= 1; x++) {
                ctx.drawImage(blurtemp2, x, y, W, H, 0, 0, game.width, game.height);
            }
        }
    }

    ctx.globalAlpha = 1.0;
}
/***********************************************************************************************/
CanvasRenderingContext2D.prototype.hasHit = function (x, y) {
	var ary;
	if (player.angle >= 0.06) {
		ary = [42, 46, 149, 183, 400, 449, 631, 743];
	} else if (player.angle <= -0.06) {
		ary = [28, 32, 125, 190, 424, 425, 643, 730];
	} else {
		ary = [11, 14, 353, 372, 650, 674, 713];
	}
	return GetDataFaster(ary, Math.floor((x - level.x - player.panx) / 2), Math.floor((y - level.y - player.pany) / 2), 25, 30, level.W, level.H, level.ary);
}
/***********************************************************************************************/
var GetDataFaster = function (a, x, y, w, h, W, H, d) {
	for (var i = 0; i <= a.length - 1; i++) {
		var X = x + (a[i] % w),
			Y = y + Math.floor(a[i] / w);
		if (X < 0 || X >= W || Y < 0 || Y >= H) continue;
		if (d[(Y * W) + X] != (0, 0, 0, 0)){
			return true;
		}
	}
	return false;
}

/***********************************************************************************************/
function Message(title, text, buttons, callback) {
    try {
        navigator.notification.confirm(
            text,
            callback,
            title,
            buttons
        );
    } catch (e) {
        var txt;
        var r = confirm(text);
        if (r == true) {
            callback(1);
        } else callback(2);
    }
}
function Ok() { }
/***********************************************************************************************/
CanvasRenderingContext2D.prototype.isInPath = function (x, y) {
    if (this.getImageData(x, y, 1, 1).data[3] == 255) return true;
    else return false;
}
/***********************************************************************************************/
window.requestAnimFrame = (function () {
    return window.requestAnimationFrame;
})();
window.cancelAnimFrame = (function () {
    return window.cancelAnimationFrame;
})();
/***********************************************************************************************/
window.GetLocalStorage = function (key, value) {
    var tmp;
    if (!(tmp = localStorage.getItem(key))) { SetLocalStorage(key, value); return value; }
    return JSON.parse(tmp);
}
window.SetLocalStorage = function (key, value) {
    localStorage.setItem(key, JSON.stringify(value));
}
/***********************************************************************************************/